<?php
class cp_Cron extends cp_Service{

	private $posts = array();
	private $infiltration;
	public $table_names;

	function __construct($tables = array(), $infiltration_id = NULL){
		global $wpdb;

		$this->table_names = $tables;
		
		if(!is_null($infiltration_id)){
			$this->infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$infiltration_id, ARRAY_A);
			$this->post = get_post($this->infiltration['post_id']);
		};
	}	

	private function log($data){
		global $wpdb;
		$wpdb->insert( 
					$this->table_names['tbl_infiltrate_history'],
						array(
							'infiltration_id' => $data['infiltration_id'],
							'user_id'=> isset($data['user_id'])?$data['user_id']:0,
							'group_id' => isset($data['group_id'])?$data['group_id']:0,
							'name' =>$data['name'],
							'post_url'=> get_permalink($data['post_id']),
							'status' => $data['status'],
							'time_send' => current_time( 'mysql' ),
							'type' => $data['type'],
							'result_url' =>  $data['result_url']
							)
						);
	}	
	
	private function closeTask($id){
		global $wpdb;
		$wpdb->update( 
				$this->table_names['tbl_cron_tasks'],
				array('state'=>'complite'),
				array('id' => $id)
				);
	}
	
	private function errorTask($id){
		global $wpdb;
		$wpdb->update( 
				$this->table_names['tbl_cron_tasks'],
				array('state'=>'error'),
				array('id' => $id)
				);
	}	
	
	public function run(){
		global $wpdb;
		echo 'Log : run() <br>';
		
		$tasks = $wpdb->get_results("SELECT task.*, messages.message, messages.media 
										FROM 	" . $this->table_names['tbl_cron_tasks'] . " task
										LEFT JOIN
										" . $this->table_names['tbl_infiltration_messages'] . " messages ON task.message_id = messages.id
										WHERE state='start' AND time_start < '".current_time( 'mysql' )."' AND  messages.id IS NOT NULL", ARRAY_A);
		
		if(!is_null($tasks)){
			foreach ($tasks as $task){
				
				if(!isset($this->posts[$task['post_id']])) $this->posts[$task['post_id']] = get_post($task['post_id']);
				
				switch ($task['soc_type']) {
					case 'facebook': {$this->run_facebook($task);}; break;
					case 'twitter': {$this->run_twitter($task);}; break;
					case 'tumblr': {$this->run_tumblr($task);}; break;
					case 'google': {$this->run_google($task);}; break;
					case 'pinterest': {$this->run_pinterest($task);}; break;
				}
			}
		};
		echo 'Log : complite() <br>';
	}

	public function create_infiltration_tasks(){
		
		$this->clear_tasks();
		$this->create_facebook_tasks();
		$this->create_twitter_tasks();
		$this->create_tumblr_tasks();
		$this->create_google_tasks();
		$this->create_pinterst_tasks();
	}
	
	public function create_task_table_list($type, $elemets_list, $infiltartion_user_field=''){
		global $wpdb;
		if(!is_null($elemets_list) && count($elemets_list)>0){
			$repeat_times = $this->infiltration['repeat_times'] + 1;
			$time_loop_start = strtotime($this->infiltration['date_start']);
			$time_loop_end = strtotime($this->infiltration['date_start']);
			//$time_loop_end = date_add($time_loop_end, date_interval_create_from_date_string($this->infiltration['duration'].' days'));
			$time_loop_end += $this->infiltration['duration']*24*60*60;
			
			$time_now = strtotime(current_time( 'mysql' ));
			
			$post_messages = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltration_messages'] . "` WHERE type='".$type."' AND `infiltrate_id`= ". $this->infiltration['id'], ARRAY_A);
			if(is_null($post_messages)){
				$post_messages[] = array('message'=> $this->post->post_content, 'media'=>''); 
			}else{
				shuffle($post_messages);
			};
			
			
			$m_index = 0;
			for ($index = 0; $index < $repeat_times; $index++) {
				unset($time_start);
				$time_start = $time_loop_start;
				
				foreach ($elemets_list as $key => $elemet){
					if($time_start < $time_now || $time_start > $time_loop_end){
						$random_minuts_interval = rand($this->infiltration['time_min'], $this->infiltration['time_max']);
						$time_start += $random_minuts_interval*60;
						continue;
					}	

					if('' == $infiltartion_user_field){
						$data = array(
									'time_start' => gmdate('Y-m-d H:i:s', $time_start),
									'infiltrate_id'=> $this->infiltration['id'],
									'post_id' => $this->infiltration['post_id'],
									'message_id' => $post_messages[$m_index]['id'],
									'soc_type' => $type,
									'soc_account_id'=> $elemet['user_id'],
									'target' => ('pinterest' == $type)?$elemet['board_id']:$elemet['user_id'],
								);
					}else{
						$data = array(
									'time_start' => gmdate('Y-m-d H:i:s', $time_start),
									'infiltrate_id'=> $this->infiltration['id'],
									'post_id' => $this->infiltration['post_id'],
									'message_id' => $post_messages[$m_index]['id'],
									'soc_type' => $type,
									'soc_account_id'=> $this->infiltration[$infiltartion_user_field],
									'target' => $elemet['group_id'],
								);							
					};

					$wpdb->insert( $this->table_names['tbl_cron_tasks'], $data);

					$m_index += 1;
					if(count($post_messages)< $m_index + 1){
						$m_index = 0;
					};

					$random_minuts_interval = rand($this->infiltration['time_min'], $this->infiltration['time_max']);
					$time_start += $random_minuts_interval*60;
				};
				
				$time_loop_end += ($this->infiltration['duration'] + $this->infiltration['repeat_period'])*24*60*60;
				$time_loop_start += ($this->infiltration['duration'] + $this->infiltration['repeat_period'])*24*60*60;;
			}	
		}		
	}

	public function clear_tasks(){
		global $wpdb;
		$wpdb->delete( $this->table_names['tbl_cron_tasks'], array('infiltrate_id' => $this->infiltration['id']));
	}

	protected function create_facebook_tasks(){
		global $wpdb;
		
		/* TASKS TO POSTING TO GROUPS  */
		$packeges = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_package_fb'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		
		if(count($packeges)>0){
			$groups_fb = $wpdb->get_results("SELECT groups.id_group as 'group_id', groups.name FROM " . $this->table_names['tbl_group_fb'] . " groups
				LEFT JOIN  " . $this->table_names['tbl_infiltrat_package_fb'] . " packeg
				ON groups.id_package = packeg.packeg_id
				WHERE packeg.infiltration_id = ". $this->infiltration['id'], ARRAY_A);
		}else{
			$groups_fb = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_group_fb'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		};

		if(!is_null($groups_fb) && count($groups_fb)>0){
			$this->create_task_table_list('facebook', $groups_fb, 'fb_user_id');
		};
		
		/* TASKS TO POSTING TO USER WALL  */
		$inf_users = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_users_fb'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		if(count($inf_users>0)){
			$this->create_task_table_list('facebook', $inf_users);
		}
	}
	
	protected function create_twitter_tasks(){
		global $wpdb;
		
		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_users_tw'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		
		if(!is_null($accounts) && count($accounts)>0){
			$this->create_task_table_list('twitter', $accounts);
		}
	}

	protected function create_google_tasks(){
		global $wpdb;

		/* TASKS TO POSTING TO USER WALL  */
		$inf_users = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_users_gp'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		if(count($inf_users>0)){
			$this->create_task_table_list('google', $inf_users);
		};
		
		/* TASKS TO POSTING TO COMMUNITIES WALL  */
		$comunities = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_group_gp'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		
		if(is_null($comunities)) $comunities = array();
		
		$packages_ids = $wpdb->get_col(
			$wpdb->prepare(
					"SELECT packeg_id FROM ".$this->table_names['tbl_infiltrat_package_gp']." WHERE infiltration_id = %d ",
					$this->infiltration['id']	
					) 
			);
		
		if(!is_null($packages_ids) && count($packages_ids)>0){
			$in_string = implode(',', $packages_ids);
			$comunities2 = $wpdb->get_results("SELECT DISTINCT group_packages.group_id, groups.* FROM " . $this->table_names['tbl_group_package_gp'] . " group_packages INNER JOIN " . $this->table_names['tbl_group_gp'] . " groups ON group_packages.group_id = groups.id_group WHERE group_packages.package_id in (".$in_string.")", ARRAY_A);
			foreach ($comunities2 as $comunitie2) {
				$comunities[] = $comunitie2;
			}			
		}

		if(count($comunities>0)){
			$this->create_task_table_list('google', $comunities, 'gp_user_id');
		}
		
		
	}
	
	protected function create_tumblr_tasks(){
		global $wpdb;
		
		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_users_tm'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		
		if(!is_null($accounts)){
			$this->create_task_table_list('tumblr', $accounts);
		}		
	}
	
	protected function create_pinterst_tasks(){
		global $wpdb;
	
		/* TASKS TO POSTING TO USER WALL  */
		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_users_pn'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		if(count($inf_users>0)){
			$this->create_task_table_list('pinterest', $accounts);
		}		
	}	
	
	protected function run_facebook($task){
		global $wpdb;

		if(!isset($this->facebook)){
			$fb_config = $this->sp_get_option('cp_facebook_app_settings');
			$this->facebook = new cp_Facebook($fb_config);
		};		
		
		$fb_user  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_account_fb'] . "` WHERE `fb_id`= ". $task['soc_account_id'], ARRAY_A); 
		$infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `id`= ". $task['infiltrate_id'], ARRAY_A); 
		$additional_fb_params = array('message' => $task['message'], 'media' => $task['media'], 'url' => $infiltration['short_url']);

		if($task['target'] != $task['soc_account_id']){
			$fb_group = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltrat_group_fb'] . "` WHERE `group_id`= ". $task['target'], ARRAY_A); 

			try {
				$res = $this->facebook->post_from_user($fb_user, $this->posts[$task['post_id']], $task['target'], $additional_fb_params);
			} catch (Exception $exc) {		}

			if(isset($res['id'])) $url_ids = explode('_', $res['id']);
			
			$this->log(array(
						'infiltration_id' => $task['infiltrate_id'],
						'group_id'=> $fb_group['group_id'],
						'name' => $fb_group['group_name'],
						'post_id'=> $task['post_id'],
						'status' => (isset($res['id']))?'OK':'ERROR',
						'type' => 'Facebook Group',
						'result_url' => (isset($res) && $res)?'https://www.facebook.com/groups/'.$url_ids[0].'/permalink/'.$url_ids[1]:NULL
					));
			echo var_dump($res).'<br>';
			if(isset($res['id'])) 
				$this->closeTask($task['id']);
			else 
				$this->errorTask($task['id']);
			
		}else{
			try {
				$res = $this->facebook->post_from_user($fb_user, $this->posts[$task['post_id']], $task['soc_account_id'], $additional_fb_params);
			} catch (Exception $exc) {
				
			};

			if(isset($res['id'])) $url_ids = explode('_', $res['id']);
			
			$this->log(array(
						'infiltration_id' => $task['infiltrate_id'],
						'user_id'=> $fb_group['id'],
						'name' => $fb_user['name'],
						'post_id'=> $task['post_id'],
						'status' => (isset($res['id']))?'OK':'ERROR',
						'type' => 'Facebook Account',
						'result_url' => (isset($res) && $res)?'https://www.facebook.com/'.$url_ids[0].'/posts/'.$url_ids[1]:NULL
					));
			echo var_dump($res).'<br>';
			if(isset($res['id']))
				$this->closeTask($task['id']);
			else 
				$this->errorTask($task['id']);
		};		

		echo 'Log : run_facebook()'.$task['soc_account_id'].' <br>';
	}
	
	protected function run_twitter($task){
		global $wpdb;
		
		$infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `id`= ". $task['infiltrate_id'], ARRAY_A); 
		$user_tw = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_account_tw'] . "` WHERE `tw_id`= ". $task['soc_account_id'], ARRAY_A);
		$post = $this->posts[$task['post_id']];

		$additional_tw_params = array('message' => $task['message'], 'media' => $task['media'], 'url' => $infiltration['short_url']);

		if(!is_null($user_tw)){
			$tw_settings = $this->sp_get_option('cp_twitter_app_settings');
			$twitter = new cp_Twitter($tw_settings);		
			
			$res = $twitter->post_from_user($user_tw, $post, $additional_tw_params);
			$this->log(array(
						'infiltration_id' => $task['infiltrate_id'],
						'user_id'=> $user_tw['id'],
						'name' => $user_tw['name'],
						'post_id'=> $task['post_id'],
						'status' => (isset($res) && $res)?'OK':'ERROR',
						'type' => 'Twitter',
						'result_url' => (isset($res) && $res)?'https://twitter.com/'.$user_tw['name']:NULL
					));	
			echo var_dump($res).'<br>';
			if(isset($res) && $res) 
				$this->closeTask($task['id']);
			else 
				$this->errorTask($task['id']);
		};
		echo 'Log : run_twitter()'.$task['soc_account_id'].' <br>';
	}
	
	protected function run_tumblr($task){
		global $wpdb;

		$infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `id`= ". $task['infiltrate_id'], ARRAY_A); 
		$user_tm = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_account_tumblr'] . "` WHERE `tm_id`= '". $task['soc_account_id']."'", ARRAY_A);
		$post = $this->posts[$task['post_id']];		
		
		$additional_tm_params = array(
									'message' => $task['message'],
									'media' => $task['media'],
									'title' => $infiltration['tm_title'],
									'tags' => $infiltration['tm_tags'],
									'url' => $infiltration['short_url']
								);

		if(!is_null($user_tm)){
			$tm_config = $this->sp_get_option('cp_tumblr_app_settings');
			$tumblr = new cp_Tumblr($tm_config);
			echo 'Befor post tumbler<br>';
			$res = $tumblr->post_from_user($user_tm, $post, $additional_tm_params);
			var_dump($res);
			echo 'after post tumbler<br>';
			$this->log(array(
						'infiltration_id' => $task['infiltrate_id'],
						'user_id'=> $user_tm['id'],
						'name' => $user_tm['name'],
						'post_id'=> $task['post_id'],
						'status' => (isset($res) && $res)?'OK':'ERROR',
						'type' => 'Tumblr',
						'result_url' => isset($res->response->id)?'http://'.$user_tm['tm_id'].'.tumblr.com/post/'.$res->response->id:NULL
					));
			echo var_dump($res).'<br>';
			if(isset($res->response->id))
				$this->closeTask($task['id']);
			else 
				$this->errorTask($task['id']);
		};
		
		echo 'Log : run_tumblr() task_account='.$task['soc_account_id'].'  post_id='.$task['post_id'].'<br>';
	}
	
	protected function run_google($task){
		global $wpdb;

		$infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `id`= ". $task['infiltrate_id'], ARRAY_A); 
		$user = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_account_gp'] . "` WHERE `id`= '". $task['soc_account_id']."'", ARRAY_A);
		$message = 	$wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration_messages'] . "` WHERE `id`= '". $task['message_id']."'", ARRAY_A);	
		$post = $this->posts[$task['post_id']];		
		
		$additional_params = array('message' => $message['message'], 'media' => $message['media'], 'url' => $infiltration['short_url']);
		
		$google = new cp_Google('');
		
		if($task['target'] == $task['soc_account_id']){
			if(!is_null($user)){
				$res = $google->post_from_user($user, $post, $additional_params);
				$this->log(array(
							'infiltration_id' => $task['infiltrate_id'],
							'user_id'=> $user['id'],
							'name' => $user['mail'],
							'post_id'=> $task['post_id'],
							'status' => (isset($res) && $res)?'OK':'ERROR',
							'type' => 'Google User',
							'result_url' => (isset($res) && $res)?$res['post_url']:NULL
						));
				echo var_dump($res).'<br>';
				if(isset($res) && $res) 
					$this->closeTask($task['id']);
				else 
					$this->errorTask($task['id']);
			};
		}else{
			if(!is_null($user)){
				$res = $google->post_to_community($user, $task['target'], $post, $additional_params);
				$gp_group = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_group_gp'] . "` WHERE `id_group`= ". $task['target'], ARRAY_A); 
				
				$this->log(array(
							'infiltration_id' => $task['infiltrate_id'],
							'user_id'=> $user['id'],
							'name' => $gp_group['name'],
							'post_id'=> $task['post_id'],
							'status' => $res?'OK':'ERROR',
							'type' => 'Google Community',
							'result_url' => (isset($res) && $res)?'https://plus.google.com/u/0/communities/'.$task['target']:NULL
						));
				echo var_dump($res).'<br>';
				if(isset($res) && $res) 
					$this->closeTask($task['id']);
				else 
					$this->errorTask($task['id']);
			};			
		}	

		echo 'Log : run_google()'.$task['soc_account_id'].' <br>';
	}
	
	protected function run_pinterest($task){
		global $wpdb;

		$infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `id`= ". $task['infiltrate_id'], ARRAY_A); 
		$user = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_account_pinterest'] . "` WHERE `id`= '". $task['soc_account_id']."'", ARRAY_A);
		$message = 	$wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration_messages'] . "` WHERE `id`= '". $task['message_id']."'", ARRAY_A);	
		$post = $this->posts[$task['post_id']];		
		
		$additional_params = array(
			'message' => $message['message'],
			'media' => $message['media'],
			'url' => $infiltration['short_url'],
			'board_id' => $task['target']
			);
		
		if(!is_null($user)){
			$config = $this->sp_get_option('cp_pinterest_app_settings');
			$pinterest = new cp_Pinterest($config);
			
			$res = $pinterest->post($user, $post, $additional_params);
			$this->log(array(
						'infiltration_id' => $task['infiltrate_id'],
						'user_id'=> $user['id'],
						'name' => ('' == $user['name'])?$user['login']:$user['name'],
						'post_id'=> $task['post_id'],
						'status' => (isset($res) && $res)?'OK':'ERROR',
						'type' => 'Pinterest',
						'result_url' => (isset($res) && $res)?'http://www.pinterest.com/pin/'.$res['post_id']:NULL
					));
			echo var_dump($res).'<br>';
			if(isset($res) && $res)
				$this->closeTask($task['id']);
			else 
				$this->errorTask($task['id']);
		};

		echo 'Log : run_pinterest()'.$task['soc_account_id'].' <br>';
	}
}

?>
