<?php
class cp_Cron extends cp_Service{

	private $posts = array();
	private $infiltration;
	public $table_names;

	function __construct($tables = array(), $infiltration_id = NULL){
		global $wpdb;

		$this->table_names = $tables;
		
		if(!is_null($infiltration_id)){
			$this->infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$infiltration_id, ARRAY_A);
			$this->post = get_post($this->infiltration['post_id']);
		};
	}	

	private function log($data){
		global $wpdb;
		$wpdb->insert( 
					$this->table_names['tbl_infiltrate_history'],
						array(
							'infiltration_id' => $data['infiltration_id'],
							'user_id'=> isset($data['user_id'])?$data['user_id']:0,
							'group_id' => isset($data['group_id'])?$data['group_id']:0,
							'name' =>$data['name'],
							'post_url'=> get_permalink($data['post_id']),
							'status' => $data['status'],
							'time_send' => current_time( 'mysql' ),
							'type' => $data['type'],
							'result_url' =>  $data['result_url']
							)
						);
	}	
	
	private function closeTask($id){
		global $wpdb;
		$wpdb->update( 
				$this->table_names['tbl_cron_tasks'],
				array('state'=>'complite'),
				array('id' => $id)
				);
	}
	
	private function errorTask($id){
		global $wpdb;
		$wpdb->update( 
				$this->table_names['tbl_cron_tasks'],
				array('state'=>'error'),
				array('id' => $id)
				);
	}		
	
	public function run(){
		global $wpdb;
		echo 'Log : run() <br>';
		
		$tasks = $wpdb->get_results("SELECT task.*, messages.message, messages.media 
										FROM 	" . $this->table_names['tbl_cron_tasks'] . " task
										LEFT JOIN
										" . $this->table_names['tbl_infiltration_messages'] . " messages ON task.message_id = messages.id
										WHERE state='start' AND time_start < '".current_time( 'mysql' )."' AND  messages.id IS NOT NULL", ARRAY_A);
		
		if(!is_null($tasks)){
			foreach ($tasks as $task){
				
				if(!isset($this->posts[$task['post_id']])) $this->posts[$task['post_id']] = get_post($task['post_id']);
				
				switch ($task['soc_type']) {
					case 'facebook': {$this->run_facebook($task);}; break;
					case 'twitter': {$this->run_twitter($task);}; break;
					case 'tumblr': {$this->run_tumblr($task);}; break;
					case 'google': {$this->run_google($task);}; break;
					case 'pinterest': {$this->run_pinterest($task);}; break;
				}
			}
		};
		echo 'Log : complite() <br>';
	}

	public function create_infiltration_tasks(){
		
		$this->clear_tasks();
//		$this->create_facebook_tasks();
//		$this->create_twitter_tasks();
//		$this->create_tumblr_tasks();
		$this->create_google_tasks();
//		$this->create_pinterst_tasks();
	}
	
	public function create_task_table_list($type, $elemets_list, $infiltartion_user_field=''){
		global $wpdb;
		if(!is_null($elemets_list) && count($elemets_list)>0){
			$repeat_times = $this->infiltration['repeat_times'] + 1;
			$time_loop_start = strtotime($this->infiltration['date_start']);
			$time_loop_end = strtotime($this->infiltration['date_start']);
			//$time_loop_end = date_add($time_loop_end, date_interval_create_from_date_string($this->infiltration['duration'].' days'));
			$time_loop_end += $this->infiltration['duration']*24*60*60;
			
			$time_now = strtotime(current_time( 'mysql' ));
			
			$post_messages = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltration_messages'] . "` WHERE type='".$type."' AND `infiltrate_id`= ". $this->infiltration['id'], ARRAY_A);
			if(is_null($post_messages)){
				$post_messages[] = array('message'=> $this->post->post_content, 'media'=>''); 
			}else{
				shuffle($post_messages);
			};
			
			
			$m_index = 0;
			for ($index = 0; $index < $repeat_times; $index++) {
				unset($time_start);
				$time_start = $time_loop_start;
				
				foreach ($elemets_list as $key => $elemet){
					if($time_start < $time_now || $time_start > $time_loop_end){
						$random_minuts_interval = rand($this->infiltration['time_min'], $this->infiltration['time_max']);
						$time_start += $random_minuts_interval*60;
						continue;
					}	

					if('' == $infiltartion_user_field){
						$data = array(
									'time_start' => gmdate('Y-m-d H:i:s', $time_start),
									'infiltrate_id'=> $this->infiltration['id'],
									'post_id' => $this->infiltration['post_id'],
									'message_id' => $post_messages[$m_index]['id'],
									'soc_type' => $type,
									'soc_account_id'=> $elemet['user_id'],
									'target' => ('pinterest' == $type)?$elemet['board_id']:$elemet['user_id'],
								);
					}else{
						$data = array(
									'time_start' => gmdate('Y-m-d H:i:s', $time_start),
									'infiltrate_id'=> $this->infiltration['id'],
									'post_id' => $this->infiltration['post_id'],
									'message_id' => $post_messages[$m_index]['id'],
									'soc_type' => $type,
									'soc_account_id'=> $this->infiltration[$infiltartion_user_field],
									'target' => $elemet['group_id'],
								);							
					};

					$wpdb->insert( $this->table_names['tbl_cron_tasks'], $data);

					$m_index += 1;
					if(count($post_messages)< $m_index + 1){
						$m_index = 0;
					};

					$random_minuts_interval = rand($this->infiltration['time_min'], $this->infiltration['time_max']);
					$time_start += $random_minuts_interval*60;
				};
				
				$time_loop_end += ($this->infiltration['duration'] + $this->infiltration['repeat_period'])*24*60*60;
				$time_loop_start += ($this->infiltration['duration'] + $this->infiltration['repeat_period'])*24*60*60;;
			}	
		}		
	}

	public function clear_tasks(){
		global $wpdb;
		$wpdb->delete( $this->table_names['tbl_cron_tasks'], array('infiltrate_id' => $this->infiltration['id']));
	}

	protected function create_facebook_tasks(){
	}
	
	protected function create_twitter_tasks(){
	}

	protected function create_google_tasks(){
		global $wpdb;

		/* TASKS TO POSTING TO USER WALL  */
		$inf_users = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_users_gp'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		if(count($inf_users>0)){
			$this->create_task_table_list('google', $inf_users);
		};
		
		/* TASKS TO POSTING TO COMMUNITIES WALL  */
		$comunities = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_group_gp'] . "` WHERE `infiltration_id`= ". $this->infiltration['id'], ARRAY_A);
		
		if(is_null($comunities)) $comunities = array();
		
		$packages_ids = $wpdb->get_col(
			$wpdb->prepare(
					"SELECT packeg_id FROM ".$this->table_names['tbl_infiltrat_package_gp']." WHERE infiltration_id = %d ",
					$this->infiltration['id']	
					) 
			);
		
		if(!is_null($packages_ids) && count($packages_ids)>0){
			$in_string = implode(',', $packages_ids);
			$comunities2 = $wpdb->get_results("SELECT DISTINCT group_packages.group_id, groups.* FROM " . $this->table_names['tbl_group_package_gp'] . " group_packages INNER JOIN " . $this->table_names['tbl_group_gp'] . " groups ON group_packages.group_id = groups.id_group WHERE group_packages.package_id in (".$in_string.")", ARRAY_A);
			foreach ($comunities2 as $comunitie2) {
				$comunities[] = $comunitie2;
			}			
		}

		if(count($comunities>0)){
			$this->create_task_table_list('google', $comunities, 'gp_user_id');
		}
		
		
	}
	
	protected function create_tumblr_tasks(){
	}
	
	protected function create_pinterst_tasks(){
	}	
	
	protected function run_facebook($task){
	}
	
	protected function run_twitter($task){
	}
	
	protected function run_tumblr($task){
	}
	
	protected function run_google($task){
		global $wpdb;

		$infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `id`= ". $task['infiltrate_id'], ARRAY_A); 
		$user = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_account_gp'] . "` WHERE `id`= '". $task['soc_account_id']."'", ARRAY_A);
		$message = 	$wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration_messages'] . "` WHERE `id`= '". $task['message_id']."'", ARRAY_A);	
		$post = $this->posts[$task['post_id']];		
		
		$additional_params = array('message' => $message['message'], 'media' => $message['media'], 'url' => $infiltration['short_url']);
		
		$google = new cp_Google('');
		
		if($task['target'] == $task['soc_account_id']){
			if(!is_null($user)){
				$res = $google->post_from_user($user, $post, $additional_params);
				$this->log(array(
							'infiltration_id' => $task['infiltrate_id'],
							'user_id'=> $user['id'],
							'name' => $user['mail'],
							'post_id'=> $task['post_id'],
							'status' => (isset($res) && $res)?'OK':'ERROR',
							'type' => 'Google User',
							'result_url' => (isset($res) && $res)?$res['post_url']:NULL
						));
				echo var_dump($res).'<br>';
				if(isset($res) && $res) 
					$this->closeTask($task['id']);
				else 
					$this->errorTask($task['id']);
			};
		}else{
			if(!is_null($user)){
				$res = $google->post_to_community($user, $task['target'], $post, $additional_params);
				$gp_group = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_group_gp'] . "` WHERE `id_group`= ". $task['target'], ARRAY_A); 
				
				$this->log(array(
							'infiltration_id' => $task['infiltrate_id'],
							'user_id'=> $user['id'],
							'name' => $gp_group['name'],
							'post_id'=> $task['post_id'],
							'status' => (isset($res) && $res)?'OK':'ERROR',
							'type' => 'Google Community',
							'result_url' => (isset($res) && $res)?'https://plus.google.com/u/0/communities/'.$task['target']:NULL
						));
				echo var_dump($res).'<br>';
				if(isset($res) && $res)
					$this->closeTask($task['id']);
				else 
					$this->errorTask($task['id']);
			};			
		}	

		echo 'Log : run_google()'.$task['soc_account_id'].' <br>';
	}
	
	protected function run_pinterest($task){
	}
}

?>
