<?php
	class cp_Infiltration extends cp_Service{
		public $table_names;
		public $id;
		public $global_params;

		function __construct($tables, $id, $params = array()){
			$this->id = $id;
			$this->table_names = $tables;
			$this->global_params = $params;
		}
		
		public function cron(){
			global $wpdb;
	
			require_once('cp_Cron.php');
			$cron = new cp_Cron($this->table_names, $this->id);
			$cron->create_infiltration_tasks();
		}		
		
		public function start_cron(){
			global $wpdb;
			
			if(!class_exists('cp_Cron')){
				require_once( 'cp_Cron.php' );
			};
			
			$cron = new cp_Cron($this->table_names);
			$cron->run();
		}

		public function get_spintaxes($type){
			global $wpdb;
			
			$arr_messages =  $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltration_messages'] . "` WHERE  type='$type' AND `infiltrate_id`= ". (int)$this->id, ARRAY_A);
			$arr_spintaxes =  $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltration_spintaxes'] . "` WHERE  type='$type' AND `infiltrate_id`= ". (int)$this->id, ARRAY_A);
			
			$spintaxes = array();
			foreach ($arr_spintaxes as $key=>$spintax) {
				$spintaxes[$key]['spin'] = $spintax;
				
				$messages = array();
				foreach ($arr_messages as $m_key => $message) {
					if($message['spintax_id'] == $spintax['id']){
						$messages[] = $message;
						unset($arr_messages[$m_key]);
					}
				}
				
				$spintaxes[$key]['messages'] = $messages;
			}	
			return $spintaxes;
		}

		public function set_spintaxes($type){
			global $wpdb;

			$wpdb->delete( $this->table_names['tbl_infiltration_spintaxes'], array('infiltrate_id' => $this->id, 'type'=> $type), array('%d', '%s')); 
			$wpdb->delete( $this->table_names['tbl_infiltration_messages'], array('infiltrate_id' => $this->id, 'type'=> $type), array('%d', '%s')); 

			if(isset($_POST['spintaxes'])){
				foreach ($_POST['spintaxes'] as $key => $spintax){
					if('' != $spintax){
						$is_inserted = $wpdb->insert( 
							$this->table_names['tbl_infiltration_spintaxes'],
							array('message' => $spintax, 'media' => $_POST['media'][$key], 'infiltrate_id' => $this->id, 'type'=>$type),
							array('%s', '%s', '%d', '%s')
						);	

						$spintax_id = $wpdb->insert_id;

						$madias = array();
						if(false != strpos($_POST['media'][$key], '|')){
							$madias = explode('|', $_POST['media'][$key]);
						}else{
							$madias[0] = $_POST['media'][$key];
						}

						if(false != strpos($_POST['spintaxes'][$key], '}')){
							if(isset($_POST['messages']) && false != $is_inserted){
								foreach ($_POST['messages'][$key] as $key_m => $message_text){
									
									
									if(count($madias)>0){
										$media_url = $madias[rand(0, count($madias)-1)];	
									}else{
										$media_url = $madias[0];
									}
									
									
									if('' != $message_text){
										$wpdb->insert( 
											$this->table_names['tbl_infiltration_messages'],
											array('message' => $message_text, 'media' =>  trim($media_url), 'infiltrate_id' => $this->id, 'spintax_id' => $spintax_id, 'type'=>$type),
											array('%s', '%s', '%d', '%d', '%s')
											);	
									};
								};
							};						
						}else{
							$wpdb->insert( 
								$this->table_names['tbl_infiltration_messages'],
								array('message' => $spintax, 'media' => $madias[0], 'infiltrate_id' => $this->id, 'spintax_id' => $spintax_id, 'type'=>$type),
								array('%s', '%s', '%d', '%d', '%s')
								);										
						};

					};
				};
			};
		}

		public function start(){
			global $wpdb;
			$wpdb->update( $this->table_names['tbl_cron_tasks'], array('state' => 'start'), array('infiltrate_id' => $this->id, 'state' => 'pause')); 
			$wpdb->update( $this->table_names['tbl_infiltration'], array('pause' => '0'), array('id' => $this->id)); 
			$this->show_infiltrations();			
		}
		
		public function pause(){
			global $wpdb;
			$wpdb->update( $this->table_names['tbl_cron_tasks'], array('state' => 'pause'), array('infiltrate_id' => $this->id, 'state' => 'start')); 
			$wpdb->update( $this->table_names['tbl_infiltration'], array('pause' => '1'), array('id' => $this->id)); 
			$this->show_infiltrations();			
		}		
		
		public function delete(){
			global $wpdb;
			$wpdb->query("DELETE FROM `".$this->table_names['tbl_infiltration']."` WHERE `ID` = '". $this->id ."'");
			$this->show_infiltrations();			
		}

		public function show_fb($new_id = null){
			global $wpdb;
			
			if(!is_null($new_id)) $this->id = $new_id;
			
			$user_groups = array();
			
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
			$accounts = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_fb'] . "`", ARRAY_A);
			
			$spintaxes = $this->get_spintaxes('facebook');
			
			$coor_account = $accounts[0];
			foreach ($accounts as $t_account){
				if($t_account['fb_id'] == $infiltration['fb_user_id']) $coor_account = $t_account;
			};
			
			$selected_users_ids = $wpdb->get_col(
							$wpdb->prepare(
									"SELECT user_id FROM ".$this->table_names['tbl_infiltrat_users_fb']." WHERE infiltration_id = %d ",
									$this->id	
									) 
							); 
			
			$packeges = array();
			$selected_packeges_ids = array();
			if(isset($coor_account['fb_id'])){
				$packeges = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_package_fb'] . "` WHERE user_id = ".$coor_account['fb_id'], ARRAY_A);
				$selected_packeges_ids = $wpdb->get_col(
								$wpdb->prepare(
										"SELECT packeg_id FROM ".$this->table_names['tbl_infiltrat_package_fb']." WHERE infiltration_id = %d ",
										$this->id	
										) 
								); 					
			};

			$selected_groups_ids = array();
			if(count($accounts)>0 && count($packeges)==0){
				if(isset($this->global_params['fasebook'])){
					$facebook = $this->global_params['fasebook'];
					$user_groups = $facebook->get_usergroups($coor_account);
				};
				
				$selected_groups_ids = $wpdb->get_col(
					$wpdb->prepare(
							"SELECT group_id FROM ".$this->table_names['tbl_infiltrat_group_fb']." WHERE infiltration_id = %d ",
							$this->id	
							) 
					); 
			};
		
			$spin_rewriter = new cp_Spinrewriter();
			$spin_rewriter_enable = $spin_rewriter->isConnected();
			
			$active_state = 'fb';
			include_once('forms/create_form_fb.php');
		}
			
		public function submit_fb(){
			$this->update_fb();
			$this->show_gp($this->id);
		}

		public function update_fb(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);

			if(!is_null($infiltration)){
					$wpdb->update(
							$this->table_names['tbl_infiltration'],
							//array('fb_message' => trim($_POST['fb_message']), 'fb_media' => trim($_POST['fb_media']), 'fb_user_id'=>$_POST['fb_accounts']),
							array('fb_user_id'=>$_POST['fb_accounts']),
							array('id' => $this->id),
							array('%s'),
							array('%d')
						);
					
					$this->set_spintaxes('facebook');	
			}else{
					throw new Exception('No infiltration find.');			
			};
			
			$wpdb->delete( $this->table_names['tbl_infiltrat_group_fb'], array('infiltration_id' => $this->id));
			$wpdb->delete( $this->table_names['tbl_infiltrat_package_fb'], array('infiltration_id' => $this->id));
			if(isset($_POST['group'])){
				foreach ($_POST['group'] as $fb_group_id=>$fb_group_name) {
					if('p_' == substr($fb_group_id, 0, 2)){
						$wpdb->insert( 
								$this->table_names['tbl_infiltrat_package_fb'],
								array('packeg_id' => substr($fb_group_id, 2), 'infiltration_id' => $this->id),
								array('%s', '%s', '%d')
								);	
					}else{
						if(strlen($fb_group_id)>3)
						$wpdb->insert( 
								$this->table_names['tbl_infiltrat_group_fb'],
								array('group_id' => $fb_group_id, 'group_name'=> $fb_group_name, 'infiltration_id' => $this->id),
								array('%s', '%s', '%d')
								);					
					}
				}
			};
			
			$wpdb->delete( $this->table_names['tbl_infiltrat_users_fb'], array('infiltration_id' => $this->id));
			if(isset($_POST['fb_users'])){
				foreach ($_POST['fb_users'] as $fb_user_id => $fb_user_name) {
					if(strlen($fb_user_id)>3)
					$wpdb->insert(
							$this->table_names['tbl_infiltrat_users_fb'],
							array('infiltration_id' => $this->id, 'user_id'=>$fb_user_id),
							array('%s', '%s')
							);
				}
			};	
		}
		
		public function update_gp(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);

			if(!is_null($infiltration)){
					$wpdb->update(
							$this->table_names['tbl_infiltration'],
							array('gp_user_id'=>$_POST['gp_accounts']),
							array('id' => $this->id),
							array('%s'),
							array('%d')
						);
					
				$this->set_spintaxes('google');	
			}else{
					throw new Exception('No infiltration find.');			
			};
			
			
			$wpdb->delete( $this->table_names['tbl_infiltrat_group_gp'], array('infiltration_id' => $this->id));
			$wpdb->delete( $this->table_names['tbl_infiltrat_package_gp'], array('infiltration_id' => $this->id));
			if(isset($_POST['group'])){
				foreach ($_POST['group'] as $gp_group_id => $gp_group_name) {
					if('p_' == substr($gp_group_id, 0, 2)){
						$wpdb->insert( 
								$this->table_names['tbl_infiltrat_package_gp'],
								array('packeg_id' => substr($gp_group_id, 2), 'infiltration_id' => $this->id),
								array('%s', '%s', '%d')
						);	
					}else{
						$wpdb->insert( 
							$this->table_names['tbl_infiltrat_group_gp'],
							array('group_id' => $gp_group_id, 'group_name'=> $gp_group_name, 'infiltration_id' => $this->id),
							array('%s', '%s', '%d')
						);					
					}
				}
			};
			
			$wpdb->delete( $this->table_names['tbl_infiltrat_users_gp'], array('infiltration_id' => $this->id));
			if(isset($_POST['gp_users'])){
				foreach ($_POST['gp_users'] as $gp_user_id => $gp_user_name) {
					$wpdb->insert(
							$this->table_names['tbl_infiltrat_users_gp'],
							array('infiltration_id' => $this->id, 'user_id'=>$gp_user_id),
							array('%s', '%d')
							);
				}
			};	
		}		
		
		public function show_gp(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
			$accounts = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_gp'] . "` WHERE  pass<>'' AND NOT ISNULL(pass);", ARRAY_A);

			$spintaxes = $this->get_spintaxes('google');
			
			if(!is_null($infiltration['gp_user_id']) && '' != $infiltration['gp_user_id']){
				$selected_user_id = $infiltration['gp_user_id'];
			}elseif(count($accounts)>0){
				$selected_user_id = $accounts[0]['id'];
			}else{
				$selected_user_id = '';
			}	

			$communities = array();
			if('' != $selected_user_id){
				$communities = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_group_gp'] . "` WHERE user_id = ".$selected_user_id, ARRAY_A);
			};
			
			$selected_accounts_ids = $wpdb->get_col(
				$wpdb->prepare(
						"SELECT user_id FROM ".$this->table_names['tbl_infiltrat_users_gp']." WHERE infiltration_id = %d ",
						$this->id	
						) 
				); 
			
			$selected_groups_ids = $wpdb->get_col(
				$wpdb->prepare(
						"SELECT group_id FROM ".$this->table_names['tbl_infiltrat_group_gp']." WHERE infiltration_id = %d ",
						$this->id	
						) 
				); 
			
			

			$packeges = array();
			$selected_packeges_ids = array();
			if('' != $selected_user_id){
				$packeges = $wpdb->get_results("SELECT package.* , count(groups.group_id) as 'count_gr'
												FROM ".$this->table_names['tbl_package_gp']." package
												LEFT JOIN ".$this->table_names['tbl_group_package_gp']." groups ON groups.package_id = package.id
												WHERE package.user_id = ".$selected_user_id."
												GROUP BY package.id", ARRAY_A);

				$selected_packeges_ids = $wpdb->get_col(
								$wpdb->prepare(
										"SELECT packeg_id FROM ".$this->table_names['tbl_infiltrat_package_gp']." WHERE infiltration_id = %d ",
										$this->id	
										) 
								); 					
			}

			$active_state = 'gp';
			include_once('forms/create_form_gp.php');
		}

		public function submit_gp(){
			global $wpdb;
			if(isset($_POST['gp_groups'])){
				$wpdb->delete( $this->table_names['tbl_infiltrat_group_gp'], array('infiltration_id' => $this->id));
				foreach ($_POST['gp_groups'] as $gp_group_id) {
					$wpdb->insert($this->table_names['tbl_infiltrat_group_gp'], array('group_id' => strip_tags($gp_group_id), 'infiltration_id' => $this->id));
				}
			};

			if(isset($_POST['gp_users'])){
				$wpdb->delete( $this->table_names['tbl_infiltrat_users_gp'], array('infiltration_id' => $this->id));
				foreach ($_POST['gp_users'] as $gp_user_id) {
					$wpdb->insert( $this->table_names['tbl_infiltrat_users_gp'], array('infiltration_id' => $this->id, 'user'=>$gp_user_id));
				}
			};				

			$this->show_tw($this->id);
		}

		public function show_tw(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
			$accounts = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_tw'] . "`", ARRAY_A);
			
			$spintaxes = $this->get_spintaxes('twitter');
			
			$selected_accounts_ids = $wpdb->get_col(
							$wpdb->prepare(
									"SELECT user_id FROM ".$this->table_names['tbl_infiltrat_users_tw']." WHERE infiltration_id = %d ",
									$this->id	
									) 
							); 
			
			$active_state = 'tw';
			include_once('forms/create_form_tw.php');
		}

		public function update_tw(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);

			if(!is_null($infiltration)){
					$this->set_spintaxes('twitter');
			}else{
					throw new Exception('No infiltration find.');			
			};
			
			$wpdb->delete( $this->table_names['tbl_infiltrat_users_tw'], array('infiltration_id' => $this->id));
			if(isset($_POST['tw_users'])){
				foreach ($_POST['tw_users'] as $fb_user_id => $fb_user_name) {
					if(strlen($fb_user_id)>3)
					$wpdb->insert(
							$this->table_names['tbl_infiltrat_users_tw'],
							array('infiltration_id' => $this->id, 'user_id'=>$fb_user_id),
							array('%d', '%s')
							);
				}
			};	
		}		

		public function submit_tw(){
			$this->show_settings();
		}

		public function show_tm(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
			$accounts = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_tumblr'] . "`", ARRAY_A);

			$spintaxes = $this->get_spintaxes('tumblr');
			
			$selected_accounts_ids = $wpdb->get_col(
							$wpdb->prepare(
									"SELECT user_id FROM ".$this->table_names['tbl_infiltrat_users_tm']." WHERE infiltration_id = %d ",
									$this->id	
									) 
							); 
			
			$active_state = 'tm';
			include_once('forms/create_form_tm.php');
		}

		public function update_tm(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);

			if(!is_null($infiltration)){
					$wpdb->update(
							$this->table_names['tbl_infiltration'],
							array(
								'tm_title'   => trim($_POST['tm_title']),
								'tm_tags'    => trim($_POST['tm_tags']),
								),
							array('id' => $this->id),
							array('%s', '%s', '%s', '%s')
						);
				
					$this->set_spintaxes('tumblr');
			}else{
					throw new Exception('No infiltration find.');			
			};

			$wpdb->delete( $this->table_names['tbl_infiltrat_users_tm'], array('infiltration_id' => $this->id));
			if(isset($_POST['tm_users'])){
				foreach ($_POST['tm_users'] as $fb_user_id => $fb_user_name) {
					//if(strlen($fb_user_id)>1)
					$wpdb->insert(
							$this->table_names['tbl_infiltrat_users_tm'],
							array('infiltration_id' => $this->id, 'user_id'=>$fb_user_id),
							array('%s', '%s', '%d')
						);
				}
			};	
		}			
	
		public function show_pn(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
			$accounts = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_pinterest'] . "`", ARRAY_A);
			$boards = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_pinterest_board'] . "`", ARRAY_A);
			
			$spintaxes = $this->get_spintaxes('pinterest');
			
			$selected_accounts_ids = array();
			$selected_accounts_ids = $wpdb->get_col(
							$wpdb->prepare(
									"SELECT user_id FROM ".$this->table_names['tbl_infiltrat_users_pn']." WHERE infiltration_id = %d ",
									$this->id	
									) 
							); 

			$selected_board_ids = $wpdb->get_col(
				$wpdb->prepare(
						"SELECT board_id FROM ".$this->table_names['tbl_infiltrat_users_pn']." WHERE infiltration_id = %d ",
						$this->id	
						) 
				); 
			
			$boards_indexed = array();
			if(count($boards)>0)
				foreach ($boards as $board) {
					$board['selected'] = (in_array($board['board_id'], $selected_board_ids, $strict = true))?1:0;
					$boards_indexed[$board['user_id']][$board['board_id']] = $board;
				};

			$boards = array();			
			$active_state = 'pn';
			include_once('forms/create_form_pn.php');
		}		

		public function update_pn(){
			global $wpdb;
			$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);

			if(!is_null($infiltration)){
					$this->set_spintaxes('pinterest');
			}else{
					throw new Exception('No infiltration find.');			
			};
			
			$wpdb->delete( $this->table_names['tbl_infiltrat_users_pn'], array('infiltration_id' => $this->id));
			if(isset($_POST['boards'])){
				foreach ($_POST['boards'] as $user_id => $board_pn_id) {
					$wpdb->insert(
							$this->table_names['tbl_infiltrat_users_pn'],
							array('infiltration_id' => $this->id, 'user_id'=>$user_id, 'board_id'=>$board_pn_id),
							array('%d', '%d', '%s')
							);
				}
			};	
		}			
		
		public function show_settings(){
			global $wpdb;

			$infiltration = array();
			if(isset($this->id) && $this->id>0){
				$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
			};

			$message_count = $wpdb->get_results( 'SELECT COUNT(*) as tcount FROM '. $this->table_names['tbl_infiltration_messages'] . ' WHERE infiltrate_id = '.$this->id.' GROUP BY type');
		
			$max_count_message_per_account = 0;
			if(0 < count($message_count)){
				$max_message = max($message_count);
				$max_count_message_per_account = $max_message->tcount;
			}

			$packeges = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_infiltrat_package_fb'] . "` WHERE `infiltration_id`= ". $this->id, ARRAY_A);
			if(count($packeges)>0){
				$groups_fb_count = $wpdb->get_var("SELECT COUNT(*) FROM " . $this->table_names['tbl_group_fb'] . " groups
					LEFT JOIN  " . $this->table_names['tbl_infiltrat_package_fb'] . " packeg
					ON groups.id_package = packeg.packeg_id
					WHERE packeg.infiltration_id = ".$this->id);

			}else{
				$groups_fb_count = $wpdb->get_var("SELECT COUNT(*) FROM `" . $this->table_names['tbl_infiltrat_group_fb'] . "` WHERE `infiltration_id`= ". $this->id);
			};

			$active_state = 'settings';
			include_once('forms/create_form_settings.php');
		}	

		public function show_infiltrations() {
			global $wpdb;
			include_once(__DIR__.'/cp_Service.php');
			$service = new cp_Service();
			include_once('forms/view_infiltration.php');
		}

		public function show_create($search = ''){
			global $wpdb;

			$infiltration_name = '';
			$infiltration_posts = array();
			$posts = array();
			if(isset($this->id) && $this->id>0){
				$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
				$infiltration_name = $infiltration['name'];
			}elseif(isset($_POST['name']) && '' != $_POST['name']){
				$infiltration_name = strip_tags($_POST['name']);
			}
			
			$seletc_posts_parapms = array('order' => 'ASC', 'orderby'=>'title');
			if(isset($_GET['order_posts'])){
				$seletc_posts_parapms['orderby'] = strip_tags($_GET['order_posts']);
			};
			
			$posts_array = get_posts( array('order' => 'ASC', 'orderby'=>'title', 'posts_per_page' => 1000) );
			$pages_array = get_pages( array() );
			
			if('' != $search){
				foreach ($posts_array as $key=>$post){
					if(false === strpos($post->post_title, $search)) unset($posts_array[$key]);
				};
				
				foreach ($pages_array as $key=>$page){
					if(false === strpos($page->post_title, $search)) unset($pages_array[$key]);
				};				
			}
			
			include_once('forms/create_form.php');
		}

		public function submit_name(){
			global $wpdb;

			$corr_id = $this->id;
			if(isset($_POST['step']) && 'step next' == $_POST['step']){
				if(isset($_POST['name'])){
					$infiltration = NULL;
					if(isset($this->id) && $this->id>0){
						$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
					}

					if(isset($infiltration)){
						$wpdb->update( 
								$this->table_names['tbl_infiltration'],
								array('name'=>strip_tags($_POST['name']), 'post_id' => (int)$_POST['post']),
								array('id' => $infiltration['id'])
								);

						$corr_id = $infiltration['id'];
					}else{
						$inputData = array(
								'name'		=> strip_tags($_POST['name']),
								'post_id' => (int)$_POST['post'],
								'date_start'=> date('Y-m-d H:i:s'),
								'duration' 		=> 1,
								'time_min'		=> 5,
								'time_max'		=> 60,
								'repeat_times'  => 0,
								'repeat_period' => 0,
							);


						$wpdb->insert( $this->table_names['tbl_infiltration'], $inputData );
						$corr_id = $wpdb->insert_id;
					}				
				}

				$this->show_fb($corr_id);
			}else{
				$this->show_create($_POST['search']);
			}	
		}
		
		public function submit_settings(){
			global $wpdb;
			if( 0 < $this->id && isset($_POST['time_min'])){
				$infiltration  = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
				$bitly = new cp_Bitly($this->sp_get_option('cp_bit_ly'));
				$short_url = $bitly->get_short_url(get_permalink($infiltration['post_id']));
				
				$inputData = array(
					'short_url'     => $short_url,
					'date_start' 	=> strip_tags(str_replace('/', '-', $_POST['date_start']).':00'),
					'duration' 		=> strip_tags($_POST['duration']),
					'time_min'		=> strip_tags($_POST['time_min']),
					'time_max'		=> strip_tags($_POST['time_max']),
					'auto_adjast'   => 0,
					'repeat_times'  => strip_tags($_POST['repeat_times']),
					'repeat_period' => strip_tags($_POST['repeat_period']),
				);					
				$wpdb->update( $this->table_names['tbl_infiltration'], $inputData, array( 'ID' => $this->id));
			};

			$this->cron();
			
			$this->show_infiltrations();			
		}
		
		public function history(){
			global $wpdb;
			$service = new cp_Service();
			$infiltration_name = '';
			if(isset($_GET['id']) && $_GET['id']>0){
				$infiltration = $wpdb->get_row("SELECT * FROM `" . $this->table_names['tbl_infiltration'] . "` WHERE `ID`= ". (int)$this->id, ARRAY_A);
				$infiltration_name = '("'.$infiltration['name'].'" infitration history)';
			};
			include_once('forms/view_history.php');
		}
	}
?>
