<?php
class cp_Service{
	private function get_cron_url(){
		return $url = get_site_url().'/wp-cron.php?doing_wp_cron';
	}

	public function sp_get_option($option_name){
		$option = get_option($option_name);
		if(is_string($option)) $option = unserialize($option);
		return $option;
	}
	
	public function sp_registr_external_cron(){
		try {
			if(!file_exists( plugin_dir_path(__FILE__).'/../../../wp-cron-sp.php')){
				copy(plugin_dir_path(__FILE__).'/wp-cron-sp.php', plugin_dir_path(__FILE__).'/../../../wp-cron-sp.php');
			};

			$this->sp_check_external_cron();
		} catch (Exception $exc) {
			update_option('cp_external_cron', 
				array(
						'state' => 'disable',
						'error' => 'Unable copy cron file to WordPress base dir or worng Cron Server response',
						'last_request' => ''
					)
				);
		}
	}
	
	public function sp_check_external_cron(){
		//$response_string = file_get_contents("http://cron_serv/index.php?url=".$this->get_cron_url());
		//$response_string = file_get_contents("http://traffic-cron.rit-soft.com/index.php?url=".$this->get_cron_url());
		$response_string = file_get_contents("http://148.251.78.83/index.php?url=".$this->get_cron_url());

		try {
			$response = json_decode($response_string);
			if($response->state == 'OK'){
				update_option('cp_external_cron', 
					array(
							'state' => 'active',
							'error' => '',
							'last_request' => current_time( 'mysql' )
						)
					);
				
				return true;
			}else{
				update_option('cp_external_cron', 
					array(
							'state' => 'disable',
							'error' => 'Cron server: '.$response->text,
							'last_request' => current_time( 'mysql' )
						)
					);				
				
				return false;
			}
		} catch (Exception $exc) {
			update_option('cp_external_cron', 
				array(
						'state' => 'disable',
						'error' => 'Unable copy cron file to WordPress base dir or worng Cron Server response',
						'last_request' => ''
					)
				);
			return false;
		}		
	}
	
	public function external_cron_is_ok(){
		$cron_state = $this->sp_get_option('cp_external_cron');
		
		$time_now = strtotime(current_time( 'mysql' ));
		$time_last_check = strtotime($cron_state['last_request']);
		
		if(!$time_last_check || ($time_now - $time_last_check)/60 > 1 ){// time > 1 hour
			return $this->sp_check_external_cron();
		}else{
			if('active' == $cron_state['state']){
				return true;
			}else{
				return false;
			}
		};
	}
}