<?php
	function create_tables($obj){
		global $wpdb;

		require_once(ABSPATH . 'wp-admin/upgrade.php');
		## Определение версии mysql
		if ( version_compare(mysql_get_server_info(), '4.1.0', '>=') ) {
			if ( ! empty($wpdb->charset) )
				$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
			if ( ! empty($wpdb->collate) )
				$charset_collate .= " COLLATE $wpdb->collate";
		};
		
		$sql_table_sp_infiltration = "
				CREATE TABLE `".$obj->tbl_infiltration."` (
					`id` INT(11) NOT NULL AUTO_INCREMENT,
					`name` VARCHAR(255) NOT NULL,
					`post_id` INT(11) NOT NULL,
					`short_url` CHAR(250) NULL DEFAULT NULL,
					`date_start` DATETIME NOT NULL,
					`duration` INT(11) NOT NULL,
					`time_min` INT(11) NOT NULL,
					`time_max` INT(11) NOT NULL,
					`auto_adjast` TINYINT(4) NOT NULL DEFAULT '0',
					`repeat_times` TINYINT(4) NOT NULL DEFAULT '0',
					`repeat_period` TINYINT(4) NOT NULL DEFAULT '0',
					`fb_user_id` VARCHAR(50) NULL DEFAULT NULL,
					`gp_user_id` VARCHAR(50) NULL DEFAULT NULL,
					`tm_title` VARCHAR(250) NULL DEFAULT NULL,
					`tm_tags` VARCHAR(250) NULL DEFAULT NULL,
					`pause` TINYINT(4) NOT NULL DEFAULT '0',
					PRIMARY KEY (`id`)
				)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltration."'") != $obj->tbl_infiltration ) {
			dbDelta($sql_table_sp_infiltration);
		}

		$sql_table_sp_account_fb = "
				CREATE TABLE `".$obj->tbl_account_fb."` (
					`id` INT(11) NOT NULL AUTO_INCREMENT,
					`fb_id` VARCHAR(50) NOT NULL DEFAULT '',
					`name` VARCHAR(250) NOT NULL DEFAULT '',
					`mail` VARCHAR(250) NOT NULL DEFAULT '',
					`token` VARCHAR(250) NOT NULL DEFAULT '',
					PRIMARY KEY (`id`)
				)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_account_fb."'") != $obj->tbl_account_fb ) {
			dbDelta($sql_table_sp_account_fb);
		}
		
		$sql_table_sp_account_gp = "
				CREATE TABLE `".$obj->tbl_account_gp."` (
					`id` INT(11) NOT NULL AUTO_INCREMENT,
					`gp_id` VARCHAR(150) NOT NULL DEFAULT '',
					`name` VARCHAR(250) NULL DEFAULT NULL,
					`access_token` TEXT NULL,
					`image` VARCHAR(250) NULL DEFAULT NULL,
					`mail` VARCHAR(250) NULL DEFAULT NULL,
					`pass` VARCHAR(250) NULL DEFAULT NULL,
					PRIMARY KEY (`id`)
				)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_account_gp."'") != $obj->tbl_account_gp ) {
			dbDelta($sql_table_sp_account_gp);
		}	
		
		$sql_table_sp_account_tw = "
				CREATE TABLE `".$obj->tbl_account_tw."` (
					`id` INT(11) NOT NULL AUTO_INCREMENT,
					`tw_id` VARCHAR(50) NULL DEFAULT NULL,
					`name` VARCHAR(250) NOT NULL DEFAULT '0',
					`image` VARCHAR(250) NULL DEFAULT NULL,
					`oauth_token` VARCHAR(250) NOT NULL DEFAULT '0',
					`oauth_secret` VARCHAR(250) NOT NULL DEFAULT '0',
					PRIMARY KEY (`id`)
				)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_account_tw."'") != $obj->tbl_account_tw ) {
			dbDelta($sql_table_sp_account_tw);
		}			

		$sql_table_sp_account_tm = "
				CREATE TABLE `".$obj->tbl_account_tumblr."` (
					`id` INT(11) NOT NULL AUTO_INCREMENT,
					`tm_id` VARCHAR(250) NOT NULL,
					`name` VARCHAR(250) NOT NULL DEFAULT '0',
					`oauth_token` VARCHAR(250) NOT NULL DEFAULT '0',
					`oauth_secret` VARCHAR(250) NOT NULL DEFAULT '0',
					PRIMARY KEY (`id`)
				)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_account_tumblr."'") != $obj->tbl_account_tumblr ) {
			dbDelta($sql_table_sp_account_tm);
		}			

		$sql_table_sp_account_pn = "
				CREATE TABLE `".$obj->tbl_account_pinterest."` (
					`id` INT(11) NOT NULL AUTO_INCREMENT,
					`pn_id` TEXT NULL,
					`name` VARCHAR(250) NOT NULL DEFAULT '',
					`image` VARCHAR(250) NOT NULL DEFAULT '',
					`login` VARCHAR(50) NULL DEFAULT NULL,
					`pass` VARCHAR(50) NULL DEFAULT NULL,
					`oauth_token` VARCHAR(250) NOT NULL DEFAULT '0',
					`oauth_secret` VARCHAR(250) NOT NULL DEFAULT '0',
					PRIMARY KEY (`id`)
				)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_account_pinterest."'") != $obj->tbl_account_pinterest ) {
			dbDelta($sql_table_sp_account_pn);
		}			
		
		$sql_table_sp_account_pinterest_board = "
			CREATE TABLE `".$obj->tbl_account_pinterest_board."` (
				`id` INT(11) NOT NULL AUTO_INCREMENT,
				`user_id` INT(11) NOT NULL,
				`board_id` VARCHAR(50) NOT NULL,
				`name` VARCHAR(250) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_user_pn_board` (`user_id`),
				CONSTRAINT `FK_infiltrate_user_pn_board` FOREIGN KEY (`user_id`) REFERENCES `wp_sp_account_pn` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_account_pinterest_board."'") != $obj->tbl_account_pinterest_board ) {
			dbDelta($sql_table_sp_account_pinterest_board);
		}			
		
		
		$sql_table_sp_infiltrat_group_fb = "
			CREATE TABLE `".$obj->tbl_infiltrat_group_fb."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`group_id` VARCHAR(255) NULL DEFAULT NULL,
				`group_name` VARCHAR(255) NULL DEFAULT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_group_fb` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_group_fb` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_group_fb."'") != $obj->tbl_infiltrat_group_fb ) {
			dbDelta($sql_table_sp_infiltrat_group_fb);
		}
		
		$sql_table_sp_infiltrat_packeg_fb = "
			CREATE TABLE `".$obj->tbl_infiltrat_packeg_fb."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`packeg_id` VARCHAR(255) NULL DEFAULT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_packeg_fb` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_packeg_fb` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_packeg_fb."'") != $obj->tbl_infiltrat_packeg_fb ) {
			dbDelta($sql_table_sp_infiltrat_packeg_fb);
		}		
		
		$sql_table_sp_infiltrat_users_fb = "
			CREATE TABLE `".$obj->tbl_infiltrat_users_fb."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`user_id` VARCHAR(250) NOT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_user_fb` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_user_fb` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_users_fb."'") != $obj->tbl_infiltrat_users_fb ) {
			dbDelta($sql_table_sp_infiltrat_users_fb);
		}

		$sql_table_sp_infiltrat_group_gp = "
			CREATE TABLE `".$obj->tbl_infiltrat_group_gp."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`group_id` VARCHAR(255) NULL DEFAULT NULL,
				`group_name` VARCHAR(255) NULL DEFAULT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_group_fb` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_group_gp` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_group_gp."'") != $obj->tbl_infiltrat_group_gp ) {
			dbDelta($sql_table_sp_infiltrat_group_gp);
		}		
		
		$sql_table_sp_infiltrat_users_gp = "
			CREATE TABLE `".$obj->tbl_infiltrat_users_gp."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`user_id` VARCHAR(250) NOT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_user_gp` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_user_gp` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_users_gp."'") != $obj->tbl_infiltrat_users_gp ) {
			dbDelta($sql_table_sp_infiltrat_users_gp);
		}

		$sql_table_sp_infiltrat_users_tw = "
			CREATE TABLE `".$obj->tbl_infiltrat_users_tw."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`user_id` VARCHAR(50) NOT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_user_tw` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_user_tw` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_users_tw."'") != $obj->tbl_infiltrat_users_tw ) {
			dbDelta($sql_table_sp_infiltrat_users_tw);
		}		

		$sql_table_sp_infiltrat_users_tm = "
			CREATE TABLE `".$obj->tbl_infiltrat_users_tm."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`user_id` VARCHAR(250) NOT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_user_tm` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_user_tm` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_users_tm."'") != $obj->tbl_infiltrat_users_tm ) {
			dbDelta($sql_table_sp_infiltrat_users_tm);
		}		

		$sql_table_sp_infiltrat_users_pn = "
			CREATE TABLE `".$obj->tbl_infiltrat_users_pn."` (
				`id` INT(11) NOT NULL AUTO_INCREMENT,
				`user_id` VARCHAR(100) NOT NULL,
				`board_id` VARCHAR(100) NOT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_user_pn` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_user_pn` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_users_pn."'") != $obj->tbl_infiltrat_users_pn ) {
			dbDelta($sql_table_sp_infiltrat_users_pn);
		}		

		$sql_table_sp_infiltrate_history = "
			CREATE TABLE `".$obj->tbl_infiltrate_history."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`infiltration_id` INT(11) NULL DEFAULT NULL,
				`user_id` INT(11) NULL DEFAULT NULL,
				`group_id` INT(11) NULL DEFAULT NULL,
				`name` VARCHAR(250) NOT NULL,
				`post_url` VARCHAR(250) NOT NULL,
				`status` VARCHAR(250) NOT NULL,
				`time_send` DATETIME NOT NULL,
				`type` VARCHAR(50) NOT NULL,
				`result_url` VARCHAR(250) NULL DEFAULT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltr_history_infiltr` (`infiltration_id`)
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrate_history."'") != $obj->tbl_infiltrate_history ) {
			dbDelta($sql_table_sp_infiltrate_history);
		}	
		
		$sql_table_sp_package_fb = "
			CREATE TABLE `".$obj->tbl_package_fb."` (
				`id` INT(11) NOT NULL AUTO_INCREMENT,
				`name` VARCHAR(250) NULL DEFAULT NULL,
				`user_id` VARCHAR(50) NOT NULL,
				PRIMARY KEY (`id`)
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_package_fb."'") != $obj->tbl_package_fb ) {
			dbDelta($sql_table_sp_package_fb);
		}
		
		$sql_table_sp_group_fb = "
			CREATE TABLE `".$obj->tbl_group_fb."` (
				`id_package` INT(11) NOT NULL,
				`id_group` VARCHAR(50) NOT NULL,
				`name` VARCHAR(250) NOT NULL,
				INDEX `FK_group_package_fb` (`id_package`),
				CONSTRAINT `FK_group_package_fb` FOREIGN KEY (`id_package`) REFERENCES `wp_sp_package_fb` (`id`) ON UPDATE NO ACTION ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_group_fb."'") != $obj->tbl_group_fb ) {
			dbDelta($sql_table_sp_group_fb);
		}

		$sql_table_sp_package_gp = "
			CREATE TABLE `".$obj->tbl_package_gp."` (
				`id` INT(11) NOT NULL AUTO_INCREMENT,
				`name` VARCHAR(250) NOT NULL,
				`user_id` VARCHAR(250) NOT NULL,
				PRIMARY KEY (`id`)
			)".$charset_collate.";";
		if ( $wpdb->get_var("show tables like '".$obj->tbl_package_gp."'") != $obj->tbl_package_gp ) {
			dbDelta($sql_table_sp_package_gp);
		}
		
		$sql_table_sp_group_package_gp = "
			CREATE TABLE `".$obj->tbl_group_package_gp."` (
				`package_id` INT(11) NOT NULL,
				`group_id` VARCHAR(50) NOT NULL,
				INDEX `FK_sp_group_package_p` (`package_id`),
				CONSTRAINT `FK_sp_group_package_p` FOREIGN KEY (`package_id`) REFERENCES `wp_sp_package_gp` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";
		if ( $wpdb->get_var("show tables like '".$obj->tbl_group_package_gp."'") != $obj->tbl_group_package_gp ) {
			dbDelta($sql_table_sp_group_package_gp);
		}		

		$sql_table_sp_group_gp = "
			CREATE TABLE `".$obj->tbl_group_gp."` (
				`user_id` INT(11) NOT NULL,
				`id_group` VARCHAR(50) NOT NULL,
				`name` VARCHAR(250) NOT NULL,
				INDEX `FK1_sp_group_gp` (`user_id`),
				CONSTRAINT `FK1_sp_group_gp` FOREIGN KEY (`user_id`) REFERENCES `wp_sp_account_gp` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_group_gp."'") != $obj->tbl_group_gp ) {
			dbDelta($sql_table_sp_group_gp);
		}		

		$sql_table_sp_infiltrat_packeg_gp = "
			CREATE TABLE `".$obj->tbl_infiltrat_packeg_gp."` (
				`id` BIGINT(20) NOT NULL AUTO_INCREMENT,
				`packeg_id` VARCHAR(255) NULL DEFAULT NULL,
				`infiltration_id` INT(11) NOT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_packeg_gp` (`infiltration_id`),
				CONSTRAINT `FK_infiltrate_packeg_gp` FOREIGN KEY (`infiltration_id`) REFERENCES `wp_sp_infiltration` (`id`) ON DELETE CASCADE
			)".$charset_collate.";";
		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltrat_packeg_gp."'") != $obj->tbl_infiltrat_packeg_gp ) {
			dbDelta($sql_table_sp_infiltrat_packeg_gp);
		}			
		
		$sql_table_sp_package_tw = "
			CREATE TABLE `".$obj->tbl_package_tw."` (
				`id` INT(11) NOT NULL AUTO_INCREMENT,
				`name` VARCHAR(250) NULL DEFAULT NULL,
				PRIMARY KEY (`id`)
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_package_tw."'") != $obj->tbl_package_tw ) {
			dbDelta($sql_table_sp_package_tw);
		}		

		$sql_table_sp_package_user_tw = "
			CREATE TABLE `".$obj->tbl_package_user_tw."` (
				`id_user_tw` INT(11) NOT NULL,
				`id_package_tw` INT(11) NOT NULL
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_package_user_tw."'") != $obj->tbl_package_user_tw ) {
			dbDelta($sql_table_sp_package_user_tw);
		}		
		
		$sql_table_sp_cron_tasks = "
			CREATE TABLE `".$obj->tbl_cron_tasks."` (
				`id` INT(11) NOT NULL AUTO_INCREMENT,
				`time_start` DATETIME NOT NULL,
				`infiltrate_id` INT(11) NOT NULL,
				`post_id` INT(11) NOT NULL,
				`message_id` INT(11) NULL DEFAULT NULL,
				`soc_type` VARCHAR(50) NOT NULL DEFAULT '0',
				`soc_account_id` VARCHAR(50) NOT NULL DEFAULT '0',
				`target` VARCHAR(250) NULL DEFAULT NULL,
				`state` VARCHAR(10) NOT NULL DEFAULT 'start',
				PRIMARY KEY (`id`),
				INDEX `FK_cron_tasks` (`infiltrate_id`),
				CONSTRAINT `FK_cron_tasks` FOREIGN KEY (`infiltrate_id`) REFERENCES `wp_sp_infiltration` (`id`) ON UPDATE NO ACTION ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_cron_tasks."'") != $obj->tbl_cron_tasks ) {
			dbDelta($sql_table_sp_cron_tasks);
		}		
	
		$sql_table_sp_infiltration_spintaxes = "
			CREATE TABLE `".$obj->tbl_infiltration_spintaxes."` (
				`id` INT(11) NOT NULL AUTO_INCREMENT,
				`infiltrate_id` INT(11) NOT NULL,
				`type` VARCHAR(10) NOT NULL,
				`message` TEXT NULL,
				`media` VARCHAR(250) NULL DEFAULT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_spintaxes` (`infiltrate_id`),
				CONSTRAINT `FK_infiltrate_spintaxes` FOREIGN KEY (`infiltrate_id`) REFERENCES `wp_sp_infiltration` (`id`) ON UPDATE NO ACTION ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltration_spintaxes."'") != $obj->tbl_infiltration_spintaxes ) {
			dbDelta($sql_table_sp_infiltration_spintaxes);
		}			
		
		$sql_table_sp_infiltration_messages = "
			CREATE TABLE `".$obj->tbl_infiltration_messages."` (
				`id` INT(11) NOT NULL AUTO_INCREMENT,
				`infiltrate_id` INT(11) NOT NULL,
				`spintax_id` INT(11) NULL DEFAULT NULL,
				`type` VARCHAR(10) NOT NULL,
				`message` TEXT NULL,
				`media` VARCHAR(250) NULL DEFAULT NULL,
				`title` VARCHAR(250) NULL DEFAULT NULL,
				`tags` VARCHAR(250) NULL DEFAULT NULL,
				PRIMARY KEY (`id`),
				INDEX `FK_infiltrate_messages` (`infiltrate_id`),
				INDEX `FK2_infiltrate_messages_spintax` (`spintax_id`),
				CONSTRAINT `FK2_infiltrate_messages_spintax` FOREIGN KEY (`spintax_id`) REFERENCES `wp_sp_infiltrate_spintaxes` (`id`) ON DELETE CASCADE,
				CONSTRAINT `FK_infiltrate_messages` FOREIGN KEY (`infiltrate_id`) REFERENCES `wp_sp_infiltration` (`id`) ON UPDATE NO ACTION ON DELETE CASCADE
			)".$charset_collate.";";

		if ( $wpdb->get_var("show tables like '".$obj->tbl_infiltration_messages."'") != $obj->tbl_infiltration_messages ) {
			dbDelta($sql_table_sp_infiltration_messages);
		}			
	}
	
	function remove_tables($tables){
		global $wpdb;
		foreach ($tables as $table){
			$wpdb->query("DROP TABLE IF EXISTS ".$wpdb->prefix.$table);
		}
	}
?>
