<?php
if (!class_exists('WP_List_Table')) {
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
};

class CP_Base_List_Table extends WP_List_Table {

	function extra_tablenav($which) {
		if ($which == "top") {
			//echo"Hello, I'm before the table";
		}
		if ($which == "bottom") {
			//echo"Hi, I'm after the table";
		}
	}

	function get_table_classes() {
		return array($this->_args['plural']);
	}

	function display() {
		extract($this->_args);

		//$this->display_tablenav('top');
		?>
		<table class="wp-list-table <?php echo implode(' ', $this->get_table_classes()); ?>" cellspacing="0">
			<thead>
				<tr>
					<?php $this->print_column_headers(); ?>
				</tr>
			</thead>
			<tbody <?php if ($singular) echo " data-wp-lists='list:$singular'"; ?>>
				<?php $this->display_rows_or_placeholder(); ?>
			</tbody>
		</table>
		<?php
		$this->display_tablenav('bottom');
	}

	public function column_default($item, $column_name) {
		return $item->$column_name;
	}

	function display_tablenav($which) {
		if ('top' == $which)
			wp_nonce_field('bulk-' . $this->_args['plural']);
		?>
		<div class="program-steps-buttons">

			<div class="alignleft actions bulkactions">
				<?php $this->bulk_actions(); ?>
			</div>
			<?php
			$this->extra_tablenav($which);
			$this->pagination($which);
			?>

			<br class="clear" />
		</div>
		<?php
	}

	function pagination($which) {
		if (empty($this->_pagination_args))
			return;

		extract($this->_pagination_args, EXTR_SKIP);

		//$output = '<span class="displaying-num">' . sprintf( _n( '1 item', '%s items', $total_items ), number_format_i18n( $total_items ) ) . '</span>';

		$output = '';

		$current = $this->get_pagenum();

		$current_url = set_url_scheme('http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']);

		$current_url = remove_query_arg(array('hotkeys_highlight_last', 'hotkeys_highlight_first'), $current_url);

		$page_links = array();

		$disable_first = $disable_last = '';
		if ($current == 1)
			$disable_first = ' disabled';
		if ($current == $total_pages)
			$disable_last = ' disabled';

//		$page_links[] = sprintf( "<a class='%s' title='%s' href='%s'>%s</a>",
//			'first-page' . $disable_first,
//			esc_attr__( 'Go to the first page' ),
//			esc_url( remove_query_arg( 'paged', $current_url ) ),
//			'&laquo;'
//		);

		$page_links[] = sprintf("<li><a class='%s' title='%s' href='%s'>%s</a></li>", 'back-page' . $disable_first, esc_attr__('Go to the previous page'), esc_url(add_query_arg('paged', max(1, $current - 1), $current_url)), ' '
		);

		$page_index_start = 0;
		$page_index_end = $total_pages;
//		if($total_pages > 10){
//			
//		}
		
		
		for ($index = $page_index_start; $index < $page_index_end; $index++) {
			$page_links[] = sprintf("<li><a class='%s' title='%s' href='%s'>%s</a></li>", ($index + 1 == $current) ? 'active' : '', esc_attr__(($index + 1) . ' page'), esc_url(add_query_arg('paged', $index + 1, $current_url)), $index + 1
			);
		}

		if ('bottom' == $which)
			$html_current_page = $current;
		else
			$html_current_page = sprintf("<input class='current-page' title='%s' type='text' name='paged' value='%s' size='%d' />", esc_attr__('Current page'), $current, strlen($total_pages)
			);

//		$html_total_pages = sprintf( "<span class='total-pages'>%s</span>", number_format_i18n( $total_pages ) );
//		$page_links[] = '<span class="paging-input">' . sprintf( _x( '%1$s of %2$s', 'paging' ), $html_current_page, $html_total_pages ) . '</span>';

		$page_links[] = sprintf("<li><a class='%s' title='%s' href='%s'>%s</a></li>", 'next-page' . $disable_last, esc_attr__('Go to the next page'), esc_url(add_query_arg('paged', min($total_pages, $current + 1), $current_url)), ' '
		);

//		$page_links[] = sprintf( "<a class='%s' title='%s' href='%s'>%s</a>",
//			'last-page' . $disable_last,
//			esc_attr__( 'Go to the last page' ),
//			esc_url( add_query_arg( 'paged', $total_pages, $current_url ) ),
//			'&raquo;'
//		);

		$pagination_links_class = 'pagination-links';
		if (!empty($infinite_scroll))
			$pagination_links_class = ' hide-if-js';
		$output .= join("\n", $page_links);

		if ($total_pages)
			$page_class = $total_pages < 2 ? ' one-page' : '';
		else
			$page_class = ' no-pages';

		$this->_pagination = "<div class='si-pagination{$page_class}'><ul>$output</ul></div>";

		if($total_pages>0) echo $this->_pagination;
	}

}
?>
