<?php
if (!class_exists('CP_Base_List_Table')) {
	require_once('CP_Base_List_Table.php' );
};

class CP_History_List_Table extends CP_Base_List_Table {

	function __construct() {
		parent::__construct(array(
			'singular' => 'wp_list_text_link', //Singular label
			'plural' => 'table-infiltration-stats', //plural label, also this well be one of the table css class
			'screen' => 'edit-infiltrations',
			'ajax' => false //We won't support Ajax for this table
		));
	}

	function get_columns() {
		return $columns = array(
			'id' => __('S/N'),
			'name' => __('Profile/Group name'),
			'post_url' => __('Post URL'),
			'status' => __('Status'),
			'time_send' => __('Time sent'),
			'type' => __('Type'),
		);
	}

	public function get_sortable_columns() {
		return $sortable = array(
//			'id' => 'id',
//			'name' => 'name',
//			'post_url' => 'post_url'
		);
	}

	function prepare_items() {
		global $wpdb, $_wp_column_headers;
		$screen = get_current_screen();

		/* -- Preparing your query -- */
		if(isset($_GET['id']) && $_GET['id'] > 0){
			$query = "SELECT * FROM " . $wpdb->prefix . "sp_infiltrate_history WHERE infiltration_id=".(int)$_GET['id'];
		}else{
			$query = "SELECT * FROM " . $wpdb->prefix . "sp_infiltrate_history";
		}
		

		/* -- Ordering parameters -- */
		//Parameters that are going to be used to order the result
		$orderby = !empty($_GET["orderby"]) ? mysql_real_escape_string($_GET["orderby"]) : 'id';
		$order = !empty($_GET["order"]) ? mysql_real_escape_string($_GET["order"]) : 'DESC';
		if (!empty($orderby) & !empty($order)) {
			$query.=' ORDER BY ' . $orderby . ' ' . $order;
		}

		/* -- Pagination parameters -- */
		//Number of elements in your table?
		$totalitems = $wpdb->query($query); //return the total number of affected rows
		//How many to display per page?
		$perpage = 10;
		//Which page is this?
		$paged = !empty($_GET["paged"]) ? mysql_real_escape_string($_GET["paged"]) : '';
		//Page Number
		if (empty($paged) || !is_numeric($paged) || $paged <= 0) {
			$paged = 1;
		}
		//How many pages do we have in total?
		$totalpages = ceil($totalitems / $perpage);
		//adjust the query to take pagination into account
		if (!empty($paged) && !empty($perpage)) {
			$offset = ($paged - 1) * $perpage;
			$query.=' LIMIT ' . (int) $offset . ',' . (int) $perpage;
		}

		/* -- Register the pagination -- */
		$this->set_pagination_args(array(
			"total_items" => $totalitems,
			"total_pages" => $totalpages,
			"per_page" => $perpage,
		));
		//The pagination links are automatically built according to those parameters

		/* -- Register the Columns -- */
		$columns = $this->get_columns();
		$_wp_column_headers[$screen->id] = $columns;

		/* -- Fetch the items -- */
		$this->items = $wpdb->get_results($query);
	}

	public function column_default($item, $column_name) {
		if('status' == $column_name){
			switch ($item->$column_name) {
				case 'OK': return '<span class="si-color-success">Success</span>'; break;
				case 'WARNING': return'<span class="si-color-warning">Warning</span>'; break;
				case 'ERROR': return'<span class="si-color-error">Error</span>'; break;
				default: return'<span class="si-color-warning">Warning</span>'; break;
			};
		};
		
		if('type' == $column_name){
			$res = $item->$column_name;
			if(!is_null($item->result_url)) $res .= '<a href="'.$item->result_url.'" class="si-at-controllers at-view-post" target="_blank">view</a>';
			
			return $res;
		};
		
		

		return $item->$column_name;
	}
}
?>
