<?php
class cp_Facebook extends cp_Base{
	public $facebook_connection;

	function __construct($settings) {
		global $wpdb;
		require_once(__DIR__."/../apis/facebook.php");
		$this->connection_settings = $settings;

		$this->facebook_connection =new NXS_Facebook($settings);

		$this->tbl_account_fb   = $wpdb->prefix . 'sp_account_fb';
		$this->tbl_infiltrat_group_fb = $wpdb->prefix . 'sp_infiltrate_group_fb';
		$this->tbl_infiltrat_users_fb = $wpdb->prefix . 'sp_infiltrate_users_fb';
		$this->tbl_package_fb = $wpdb->prefix . 'sp_package_fb';
		$this->tbl_group_fb = $wpdb->prefix . 'sp_group_fb';		
   }
	
    public function show(){
		global $wpdb;
		/*  check for facebook redirect*/
		$state = isset($_GET['state']) ? trim($_GET['state']) : '';

		$app_settings = get_option('cp_facebook_app_settings');
		if (empty($app_settings['appId']) or empty($app_settings['secret']))
		{
			js_redirect('admin.php?page=manage_accounts&action=app_settings');
		}
		
		try {
			$token = $this->facebook_connection->getAccessToken();
		} catch (Exception $exc) {
			$token = null;
		}		
		
		$name = ''; 
		$login = '';
		if(trim($token) != "" && $state != "" && !is_null($token)){
			// get user profile
			// TODO make try catch
			$fb_account =$this->facebook_connection->api('me');

			$user_accounts = $wpdb->get_row("SELECT * FROM `" . $this->tbl_account_fb . "` WHERE `fb_id`= '". $fb_account['id']."'", ARRAY_A);
			if(is_null($user_accounts)){
				$wpdb->insert( $this->tbl_account_fb, 
								array(
									'fb_id' => $fb_account['id'],
									'name' => $fb_account['first_name'].' '.$fb_account['last_name'],
									'mail' => $fb_account['email'], 
									'token'=>$token
									));
			} else {
				$wpdb->update( $this->tbl_account_fb, 
								array(
									'name' => $fb_account['first_name'].' '.$fb_account['last_name'], 
									'token'=>$token
									),
								"WHERE `fb_id`= ". $user_accounts['id']
							);  
			};
		};

		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->tbl_account_fb . "`", ARRAY_A);

		$active_state = 'fb';	
		include_once(__DIR__.'/../forms/manage/facebook/show_fb.php');		
	}
   
    public function show_groups(){
		global $wpdb;

		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->tbl_account_fb . "`", ARRAY_A);
		$user_groups = array();
		if(count($accounts)>0){
			$user_groups = $this->get_usergroups($accounts[0]);
		};

		$fb_packages = $wpdb->get_results("SELECT package.* , count(groups.id_group) as 'count_gr'
											FROM $this->tbl_package_fb package
											LEFT JOIN $this->tbl_group_fb groups ON groups.id_package = package.id
											GROUP BY package.id", ARRAY_A);
		
		
		if(is_null($fb_packages)) $fb_packages = array();

		$active_state = 'fb';	
		include_once(__DIR__.'/../forms/manage/facebook/show_groups.php');		
	}	
	
	public function delete(){
		global $wpdb;
		$wpdb->delete( $this->tbl_account_fb, array( 'id' => $_GET['id'] ), array( '%d' ) );

		$this->show();			
	}
	
	public function get_usergroups($user_info){
		global $wpdb;
		if(is_null($user_info)) 
			$user_info = $wpdb->get_row("SELECT * FROM `" . $this->tbl_account_fb . "` WHERE `fb_id`= '".(int)$_GET['id']."'", ARRAY_A);

		$userPages = array();
		if(isset($user_info) && !is_null($user_info)){
			$this->facebook_connection->setAccessToken($user_info['token']);

			try {
				$user_accounts = $this->facebook_connection->api('me/accounts');
			} catch (Exception $exc) {
				$user_accounts['data'] = array();
			}

			
			foreach ($user_accounts['data'] as $key => $value){
				if($value['category'] != 'Application'){
					$userPages['pages'][] = $value;
				}
			};

			try {
				$user_groups = $this->facebook_connection->api('me/groups');
			} catch (Exception $exc) {
				$user_groups['data'] = array();
			}			

			foreach ($user_groups['data'] as $key => $value){
				$userPages['groups'][] = $value;
			}
		}

		return 	$userPages;
	}

	public function find_group($user_id, $term){
		global $wpdb;
		$user_info = $wpdb->get_row(
						$wpdb->prepare("SELECT * FROM `" . $this->tbl_account_fb . "` WHERE `fb_id`=  %s",  $user_id),
						ARRAY_A
					);

		$res_groups = array();
		if(isset($user_info) && !is_null($user_info)){
			$this->facebook_connection->setAccessToken($user_info['token']);

			try {
				$groups = $this->facebook_connection->api('v1.0/search?q=' . $term . '&type=group&limit=10');
			} catch (Exception $exc) {
				$groups = array();
			};

			foreach ($groups['data'] as $group) {
				$res_groups[] = array('name' => $group['name'], 'label' => $group['name'], 'id' => $group['id']);
			};
		}
		
		return $res_groups;
	}

	public function add_package(){
		global $wpdb;
		if(isset($_POST['name'])){
			$wpdb->insert( $this->tbl_package_fb, array('name' => strip_tags($_POST['name'])));
			$this->show();
		}else{
			include_once('/../forms/manage/facebook/add_package_fb.php');
		};		
	}
	
	private function add_groups_to_package(){
		global $wpdb;
		if(isset($_POST['fb_groups']) && count($_POST['fb_groups'])>0){
			foreach($_POST['fb_groups'] as $fb_group_id){
				$inputData = array(
					'id_package'=> intval($_POST['fb_package']),
					'id_group'  => strip_tags($fb_group_id),
					'name' 		=> 'name', //TODO get name of group from FB or from form
				);
				$wpdb->insert( $this->tbl_group_fb, $inputData );
			}
		};//fb_other_groups

		if(isset($_POST['fb_other_groups']) && count($_POST['fb_other_groups'])>0){
			foreach($_POST['fb_other_groups'] as $fb_other_group_id){
				$inputData = array(
					'id_package'=> intval($_POST['fb_package']),
					'id_group'  => strip_tags($fb_other_group_id),
					'name' 		=> 'name', //TODO get name of group from FB or from form
				);
				$wpdb->insert( $this->tbl_group_fb, $inputData );
			}
		};

		$this->show();
	}	
	
	public function post_from_user($user, WP_Post $wp_post, $facebook_object_id, $descript_params = array()){
		$data_send = $this->prepare_post($wp_post, $descript_params);
		if(isset($descript_params['message'])) $data_send['message'] = $descript_params['message'];
	
		$this->facebook_connection->setAccessToken($user['token']);
		try {
			$res = $this->facebook_connection->api('/'.$facebook_object_id.'/feed', 'POST', $data_send);
		} catch (Exception $exc) {
			echo $exc->getMessage().'<br>';
		};

		return $res;
	}
	
	public function prepare_post($wp_post, $descript_params){
		$res_post = array();
		
		$res_post['link'] = (isset($descript_params['url']) && strlen($descript_params['url'])>0)?$descript_params['url']:get_permalink($wp_post->ID);
		$res_post['message'] = 'Send from plugin';
		$res_post['name'] = $wp_post->post_title;
		$res_post['description'] = substr($wp_post->post_content, 0, 255);

		if(!is_null($descript_params['media']) && '' != $descript_params['media']){
			if(in_array(strtoupper(substr($descript_params['media'], -3)), array('PNG', 'JPG', 'GIF'))){
				$res_post['picture'] = $descript_params['media'];
			}
		};
		
		return $res_post;
	}
	
	public function app_settings(){
		if(isset($_POST['appId']) && isset($_POST['appId'])){
			$settings = array(
					'appId'=>trim($_POST['appId']),
					'secret'=>trim($_POST['secret']), 
					'fileUpload' => (isset($_POST['fileUpload']) && 1 == $_POST['fileUpload'])?true:false,
					'allowSignedRequest' => false,
				);
			
			update_option('cp_facebook_app_settings', $settings);
			
			js_redirect('admin.php?page=manage_accounts');
		}
		
		$app_settings = get_option('cp_facebook_app_settings');
		$active_state = 'fb';
		include_once(__DIR__.'/../forms/manage/facebook/app_settings.php');	
	}
}
?>
