<?php

class cp_Google{
	public $google_connection;

	function __construct($settings) {
		global $wpdb;

		$this->tbl_account_gp   = $wpdb->prefix . 'sp_account_gp';
		$this->tbl_infiltrat_group_gp = $wpdb->prefix . 'sp_infiltrate_group_gp';
		$this->tbl_infiltrat_users_gp = $wpdb->prefix . 'sp_infiltrate_users_gp';
		$this->tbl_package_gp = $wpdb->prefix . 'sp_package_gp';
		$this->tbl_group_gp = $wpdb->prefix . 'sp_group_gp';	
		$this->tbl_group_package_gp = $wpdb->prefix . 'sp_group_package_gp';
   }	
	
	public function show($loging_error=false){
		global $wpdb;
		
		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->tbl_account_gp . "`", ARRAY_A);

		$active_state = 'gp';	
		include_once(plugin_dir_path(__FILE__).'/../forms/manage/google/show_gp.php');		
	}
	
	public function add(){
		global $wpdb;

		$loging_error = false;
		
		if(isset($_POST['mail']) && filter_var($_POST['mail'], FILTER_VALIDATE_EMAIL)){
			$gp_user_info = $wpdb->get_row(	$wpdb->prepare( "SELECT * FROM `" . $this->tbl_account_gp . "` WHERE `mail`= '%s';",$_POST['mail']), ARRAY_A);
			if(is_null($gp_user_info)){
				$loginError = doConnectToGooglePlus2($_POST['mail'], $_POST['pass']);
				if(!$loginError){
					$image_url = doGetUserIcon();
					$wpdb->insert( $this->tbl_account_gp,
									array( 
										'mail' => $_POST['mail'],
										'pass' => $_POST['pass'],
										'image' => $image_url
									),
									array('%s')
							);		
					$user_id = $wpdb->insert_id;					
				}
			}else{
				$loginError = doConnectToGooglePlus2($gp_user_info['mail'], $_POST['pass']);
				if(!$loginError){
					$image_url = doGetUserIcon();
					$wpdb->update( 
						$this->tbl_account_gp, 
						array( 'pass' => $_POST['pass'], 'image' => $image_url), 
						array( 'mail' => $_POST['mail'] ),
						array('%s', '%s', '%s')
					);

					$user_id = $gp_user_info['id'];
				}
			};
			
			
			if (!$loginError) {
				$this->add_communities($user_id);
			} else {
				$loging_error = true;
			}
		};	
			
		$this->show($loging_error);	
	}
	
	public function add_communities($gp_id){
		global $wpdb;
		$com_list = doGetCommunitiesGooglePlus();
		$wpdb->delete( $this->tbl_group_gp, array( 'user_id' => $gp_id ), array( '%s' ) );
		//delete unexisting groups of user
		$wpdb->query( 
			$wpdb->prepare( 
				"
				DELETE gp FROM $this->tbl_group_package_gp gp 
				LEFT JOIN $this->tbl_group_gp g ON gp.group_id=g.id_group 
				LEFT JOIN $this->tbl_package_gp p ON gp.package_id = p.id
				WHERE p.user_id =%s AND g.id_group IS NULL;
				", $gp_id
				)
		);
		
		foreach ($com_list as $communiti) {
			$wpdb->insert( $this->tbl_group_gp,
							array( 
								'user_id' => $gp_id,
								'id_group' => $communiti['id'], 
								'name' => $communiti['name']
							),
							array('%s', '%s', '%s')
					);	
		}
	}

	public function delete(){
		global $wpdb;
		$wpdb->delete( $this->tbl_account_gp, array( 'id' => $_GET['id'] ), array( '%d' ) );

		$this->show();		
	}
	
	public function get_communities($user_id){
		global $wpdb;
		$communities = $wpdb->get_results(
				$wpdb->prepare(
						"SELECT * FROM `" . $this->tbl_group_gp . "` WHERE user_id=%s",
						$user_id),
				ARRAY_A);
		
		if(is_null($communities)) $communities = array();
		return 	$communities;		
	}
	
	public function get_packages($user_id){
		global $wpdb;
		$packages = $wpdb->get_results("SELECT package.* , count(groups.group_id) as 'count_gr'
											FROM $this->tbl_package_gp package
											LEFT JOIN $this->tbl_group_package_gp groups ON groups.package_id = package.id
											WHERE package.user_id = ".$user_id."
											GROUP BY package.id", ARRAY_A);
		if(is_null($packages)) $packages = array();
		return 	$packages;		
	}
	
	public function app_settings(){
		if(isset($_POST['ClientId']) && isset($_POST['ClientSecret']) && isset($_POST['DeveloperKey'])){
			$settings = array(
					'ClientId'=>trim($_POST['ClientId']),
					'ClientSecret'=>trim($_POST['ClientSecret']), 
					'DeveloperKey' => trim($_POST['DeveloperKey'])
				);
			
			update_option('cp_google_app_settings', $settings);
			
			js_redirect('admin.php?page=manage_accounts&action=show&type=google');
		}
		
		$app_settings = get_option('cp_google_app_settings');
		$active_state = 'gp';	
		
		include_once(plugin_dir_path(__FILE__).'/../forms/manage/google/app_settings.php');	
	}
	
	public function post_from_user($user, WP_Post $wp_post, $descript_params = array()){
		$data_send = $this->prepare_post($wp_post, $descript_params);
		$loginError = doConnectToGooglePlus2($user['mail'], $user['pass']);

		if (!$loginError)
		{
			$res = doPostToGooglePlus2($data_send['message'], $data_send['link'], '', '', $user['gp_id']); //post to profile
		} else {
			echo $loginError;
		}
		
		return $res;
	}

	public function post_to_community($user, $comm_id, WP_Post $wp_post, $descript_params = array()){
		$loginError = doConnectToGooglePlus2($user['mail'], $user['pass']);

		if (!$loginError){
			$data_send = $this->prepare_post($wp_post, $descript_params); 
			$res = doPostToGooglePlus2($data_send['message'], $data_send['link'], '', $comm_id);
			return true;
		} else {
			return false;
		}
	}	
	
	public function prepare_post($wp_post, $descript_params){
		$res_post = array();
		$res_post['link'] = doGetGoogleUrlInfo2(get_permalink($wp_post->ID));
		if($descript_params['media'] != ''){
			if(false === strpos($descript_params['media'], '//www.youtube.com')){
				$res_post['link'] = array('img'=>  $descript_params['media']); 
			}else{
				$res_post['link'] = str_replace('https://', 'http://', $descript_params['media']);
			}
		};
		
		$res_post['message'] = ('' == $descript_params['message'])?substr($wp_post->post_content, 0, 255): $descript_params['message'];
		$res_post['message'] .= '  '.get_permalink($wp_post->ID);
		$res_post['name'] = $wp_post->post_title;
		return $res_post;
	}	

    public function show_groups(){
		global $wpdb;

		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->tbl_account_gp . "`", ARRAY_A);
		if(count($accounts)>0){
			$user_groups = $this->get_communities($accounts[0]['id']);
			$packages = $this->get_packages($accounts[0]['id']);
		};
	
		$active_state = 'gp';	
		include_once(plugin_dir_path(__FILE__).'/../forms/manage/google/show_groups.php');		
	}	
}
?>
