<?php

class cp_Pinterest{
	public $pinterest_connection;
	
	function __construct($settings) {
		global $wpdb;
		$this->connection_settings = $settings;
		
		$this->pinterest_connection = new Pinterest_API();
		
		$this->tbl_account_pinterest   = $wpdb->prefix . 'sp_account_pn';
		$this->tbl_account_pinterest_board   = $wpdb->prefix . 'sp_account_pn_board';
   }	
   
    public function show(){
		global $wpdb;

		$error_message = '';
		$url = '';

		$test = $this->pinterest_connection->fetch_access_token(
					$this->connection_settings['client_id'],
					$this->connection_settings['client_secret'],
					$this->connection_settings['username'],
					$this->connection_settings['password']
				);
		
		//echo var_dump($test); 
		
		//$this->pinterest_connection = $p->some_api_call($args);
		
		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->tbl_account_pinterest . "`", ARRAY_A);

		$active_state = 'pn';	
		include_once(__DIR__.'/../forms/manage/pinterest/show.php');			
	}
	
    public function add(){
		global $wpdb;
		
		$loginError = doConnectToPinterest($_POST['login'], $_POST['pass']);
		
		if(!$loginError){
			$name = doGetPinterestUserName();
			$image = doGetPinterestUserIcon();
			$wpdb->insert( 
				$this->tbl_account_pinterest, 
				array( 'pn_id' => 0, 'pass' => $_POST['pass'], 'login' => $_POST['login'], 'name' => $name, 'image' => $image), 
				array( '%d', '%s', '%s', '%s', '%s')
			);
			$user_ins_id = $wpdb->insert_id;
			$this->update_boards($user_ins_id);
		};

		$this->show();	
	}
	
	public function update_boards($user_id){
		global $wpdb;
		$wpdb->delete($this->tbl_account_pinterest_board, array('user_id' => $user_id));
		$boards = doGetBoardsFromPinterest();
		if(count($boards)>0)
			foreach ($boards as $id=>$board) {
				$wpdb->insert( 
					$this->tbl_account_pinterest_board, 
					array( 'user_id' => $user_id, 'board_id' => $board['id'], 'name' => $board['n']), 
					array( '%d', '%s', '%s' )
				);				
			};
		$new_boards = $wpdb->get_results("SELECT * FROM `" . $this->tbl_account_pinterest_board . "` WHERE user_id =".$user_id, ARRAY_A);
		return ;	
	}

	public function delete(){
		global $wpdb;
		$wpdb->delete( $this->tbl_account_pinterest, array( 'id' => $_GET['id'] ), array( '%d' ) );

		$this->show();		
	}
	
	public function test(){
		$active_state = 'pn';
		//require_once('/../apis/NextScriptsApi/postToPinterest.php');
		include_once('/../forms/manage/pinterest/test.php');
	}
	
	public function app_settings(){
		if(isset($_POST['client_id']) && isset($_POST['client_secret'])){
			$settings = array(
					'client_id'=>$_POST['client_id'],
					'client_secret'=>$_POST['client_secret'],
					'username'=>$_POST['username'],
					'password'=>$_POST['password']				
				);
			
			update_option('cp_pinterest_app_settings', $settings);
		}
		
		$app_settings = get_option('cp_pinterest_app_settings');
		
		$active_state = 'pn';
		include_once('/../forms/manage/pinterest/app_settings.php');	
	}	
	
	public function post($user, WP_Post $wp_post, $additional_params = array()){
		//require_once('/../apis/NextScriptsApi/postToPinterest.php');
		$data_send = $this->prepare_post($wp_post, $additional_params);
		
		$loginError = doConnectToPinterest($user['login'], $user['pass']);
		
		if (!$loginError){
			$res = doPostToPinterest(
						$data_send['message'],
						$data_send['media'],
						$data_send['link'],
						$additional_params['board_id'],
						$data_send['title'],
						$price='',
						$via=''
					);
		} else {
			echo $loginError;
		}
		
		return $res;
	}
	
	public function prepare_post($wp_post, $descript_params){
		$res_post = array();
		$res_post['link'] = get_permalink($wp_post->ID);
		$res_post['message'] = ('' == $descript_params['message'])?substr($wp_post->post_content, 0, 255): $descript_params['message'];
		$res_post['title'] = $wp_post->post_title;
		$res_post['media'] = $descript_params['media'];
		
		return $res_post;
	}	
	
	public function create_board($user_id, $board_name, $board_description){
		global $wpdb;
		$user = $wpdb->get_row("SELECT * FROM `" . $this->tbl_account_pinterest . "` WHERE `id`= '". $user_id."'", ARRAY_A);
		
		$loginError = doConnectToPinterest($user['login'], $user['pass']);
		if (!$loginError){
			$result = doCreateBoard($board_name, $board_description);
			if(isset($result['code']) && $result['code'] == 'OK'){
				$wpdb->insert( 
					$this->tbl_account_pinterest_board, 
					array( 'user_id' => $user_id, 'board_id' => $result['board_id'], 'name' => $board_name), 
					array( '%d', '%s', '%s' )
				);		
				return array('succsess' => true, 'message' => "Succsess", 'data' => array('board_name' => $board_name, 'board_id' => $result['board_id']));
			}else{
				//return array('succsess' => false, 'message' => "Can't add board to Pinterest", 'data' => $result);
				 throw new Exception("Can't add board to Pinterest.");
			}
		} else {
			//return array('succsess' => false, 'message' => "Can't login to Pinterest", 'data' => $loginError);
			throw new Exception("Can't login to Pinterest");
		}
	}
	
 }
?>
