<?php

class cp_Settings extends cp_Service{

	public $temp_path;
	public $file_name;
	public $table_names;

	function __construct($settings = array()) {
		$this->temp_path = plugin_dir_path(__FILE__) . '/../temp/';
		$this->file_name = 'sp_export.json';
		$this->table_names = $settings;
	}

	public function show($message='') {
		$active_state = 'settings';
		$bitly_settings = $this->sp_get_option('cp_bit_ly');
		include_once(plugin_dir_path(__FILE__) . '/../forms/manage/settings/show.php');
	}

	public function export_data() {
		require_once(plugin_dir_path(__FILE__)."/../apis/zipstream.php");
		global $wpdb;
		$accaunts = array();
		$accaunts['facebook'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_fb'] . "`", ARRAY_A);
		$accaunts['twitter'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_tw'] . "`", ARRAY_A);
		$accaunts['tumblr'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_tumblr'] . "`", ARRAY_A);
		$accaunts['google'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_gp'] . "`", ARRAY_A);
		$accaunts['pinterest'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_account_pinterest'] . "`", ARRAY_A);

		$packeges_fb = array();
		$packeges_gp = array();
		if(isset($_GET['export_groups']) && 1 == $_GET['export_groups']){
			$packeges_fb['names'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_package_fb'] . "`", ARRAY_A);
			$packeges_fb['groups'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_group_fb'] . "`", ARRAY_A);
			
			$packeges_gp['names'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_package_gp'] . "`", ARRAY_A);
			$packeges_gp['groups'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_group_gp'] . "`", ARRAY_A);
			$packeges_gp['group_package'] = $wpdb->get_results("SELECT * FROM `" . $this->table_names['tbl_group_package_gp'] . "`", ARRAY_A);
		};	

		$result = json_encode(array(
			'accaunts' => $accaunts,
			'packeges' => array(
							'facebook' => $packeges_fb,
							'google' => $packeges_gp
						)
			));
		
		
		$zip = new ZipStream('accounts_export.zip');
		$data = "This is the contents of a dynamically generated text file.";
		$zip->add_file($this->file_name, $result);
		$zip->finish();
	}
	
	public function import_data(){
		if ( ! function_exists( 'wp_handle_upload' ) ) require_once( ABSPATH . 'wp-admin/includes/file.php' );
		$uploadedfile = $_FILES['userfile'];
		$upload_overrides = array( 'test_form' => false );
		$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
		if ( empty($movefile['error']) ) {
			$temp_dir = time().'/';
			$zip = new ZipArchive;
			if ($zip->open($movefile['file']) === TRUE) {
				$zip->extractTo($this->temp_path.$temp_dir);
				$zip->close();
				$data = file_get_contents($this->temp_path.$temp_dir.$this->file_name);
				$this->save_import_data(json_decode($data));
				unlink($this->temp_path.$temp_dir.$this->file_name);
				rmdir(substr($this->temp_path.$temp_dir, 0, strlen($this->temp_path.$temp_dir)));
			} else {
				$this->show('Unable to extract the file from the archive');
			}
		} else {
			$this->show($movefile['error']);
		}		
	}
	
	private function save_import_data($data){
		global $wpdb;
		$message = ''; 
		$result = array('fb_accounts' => 0, 'tw_accounts' => 0, 'tm_accounts' => 0, 'fb_packeges' => 0);
		
		if(isset($data->accaunts)){
			$exist_accounts_id_fb = $wpdb->get_col("SELECT distinct fb_id FROM " . $this->table_names['tbl_account_fb']);
			foreach ($data->accaunts->facebook as $fb_accaunt){
				if(!in_array($fb_accaunt->fb_id, $exist_accounts_id_fb)){
					$wpdb->insert(
							$this->table_names['tbl_account_fb'], 
							array(
								'fb_id' => $fb_accaunt->fb_id,
								'name'  => $fb_accaunt->name,
								'mail'  => $fb_accaunt->mail, 
								'token' => $fb_accaunt->token
								),
							array('%s', '%s', '%s', '%s'));
					$result['fb_accounts'] += 1;
				}
			};

			$exist_accounts_id_tw = $wpdb->get_col("SELECT distinct tw_id FROM " . $this->table_names['tbl_account_tw']);
			foreach ($data->accaunts->twitter as $tw_accaunt){
				if(!in_array($tw_accaunt->tw_id, $exist_accounts_id_tw)){
					$wpdb->insert( 
							$this->table_names['tbl_account_tw'], 
							array(
								'tw_id' => $tw_accaunt->tw_id,
								'name' => $tw_accaunt->name,
								'image' => $tw_accaunt->image, 
								'oauth_token' => $tw_accaunt->oauth_token, 
								'oauth_secret'=> $tw_accaunt->oauth_secret
								),
							array('%s', '%s', '%s', '%s', '%s'));
					$result['tw_accounts'] += 1;
				}
			};

			$exist_accounts_id_tm = $wpdb->get_col("SELECT distinct tm_id FROM " . $this->table_names['tbl_account_tumblr']);
			foreach ($data->accaunts->tumblr as $tm_accaunt){
				if(!in_array($tm_accaunt->tm_id, $exist_accounts_id_tm)){
					$wpdb->insert(
							$this->table_names['tbl_account_tumblr'], 
							array(
								'tm_id' => $tm_accaunt->tm_id,
								'name' => $tm_accaunt->name,
								'oauth_token' => $tm_accaunt->oauth_token, 
								'oauth_secret'=> $tm_accaunt->oauth_secret
								),
							array('%s', '%s', '%s', '%s')
							);
					$result['tm_accounts'] += 1;
				}
			};
			
			$exist_accounts_id_gp = $wpdb->get_col("SELECT distinct gp_id FROM " . $this->table_names['tbl_account_gp']);
			foreach ($data->accaunts->google as $gp_accaunt){
				if(!in_array($gp_accaunt->tm_id, $exist_accounts_id_gp)){
					$wpdb->insert(
							$this->table_names['tbl_account_gp'], 
							array(
								'gp_id' => $tm_accaunt->gp_id,
								'name' => $tm_accaunt->name,
								'access_token' => $tm_accaunt->access_token, 
								'image'=> $tm_accaunt->image,
								'mail' => $tm_accaunt->mail,
								'pass' => $tm_accaunt->pass
								),
							array('%s', '%s', '%s', '%s', '%s', '%s')
							);
					$result['gp_accounts'] += 1;
				}
			};	
			
			$exist_accounts_id_pn = $wpdb->get_col("SELECT distinct gp_id FROM " . $this->table_names['tbl_account_pinterest']);
			foreach ($data->accaunts->google as $gp_accaunt){
				if(!in_array($gp_accaunt->tm_id, $exist_accounts_id_pn)){
					$wpdb->insert(
							$this->table_names['tbl_account_pinterest'], 
							array(
								'pn_id' => $tm_accaunt->pn_id,
								'name' => $tm_accaunt->name,
								'oauth_token' => $tm_accaunt->oauth_token, 
								'oauth_secret'=> $tm_accaunt->oauth_secret,
								'login' => $tm_accaunt->mail,
								'pass' => $tm_accaunt->pass
								),
							array('%s', '%s', '%s', '%s', '%s', '%s')
							);
					$result['gp_accounts'] += 1;
				}
			};				
			
		}else{
			$message .= 'incorrect data format';
		};
		
		
		if(isset($data->packeges)){
			$exist_packeges_names = $wpdb->get_col("SELECT distinct name FROM " . $this->table_names['tbl_package_fb']);
			foreach ($data->packeges->packeges_fb->names as $p_name){
				$wpdb->insert( 
						$this->table_names['tbl_package_fb'], 
						array(
							'name' => in_array($p_name->name, $exist_packeges_names)?$p_name->name.'(import)':$p_name->name,
							'user_id' => $p_name->user_id, 
							),
						array('%s', '%s')
						);
				
				$new_id = $wpdb->insert_id;
				
				foreach ($data->packeges->packeges_fb->groups as $p_group){
					if($p_group->id_package == $p_name->id)
						$wpdb->insert( 
								$this->table_names['tbl_group_fb'], 
								array(
									'id_package' => $new_id,
									'id_group' => $p_group->id_group, 
									'name' => $p_group->name,
									),
								array('%d', '%s', '%s')
							);
				}
				
				$result['fb_packeges'] += 1;
			};			

			// === GOOGLE =====
			$exist_packeges_names = $wpdb->get_col("SELECT distinct name FROM " . $this->table_names['tbl_package_gp']);
			foreach ($data->packeges->packeges_gp->names as $p_name){
				$wpdb->insert( 
						$this->table_names['tbl_package_gp'], 
						array(
							'name' => in_array($p_name->name, $exist_packeges_names)?$p_name->name.'(import)':$p_name->name,
							'user_id' => $p_name->user_id, 
							),
						array('%s', '%s')
						);
//				
//				$new_id = $wpdb->insert_id;
//				
//				foreach ($data->packeges->packeges_gp->groups as $p_group){
//					if($p_group->id_package == $p_name->id)
//						$wpdb->insert( 
//								$this->table_names['tbl_group_fb'], 
//								array(
//									'id_package' => $new_id,
//									'id_group' => $p_group->id_group, 
//									'name' => $p_group->name,
//									),
//								array('%d', '%s', '%s')
//							);
//				}
//				
//				$result['gp_packeges'] += 1;
			};				
		};
		
		
		if($result['fb_accounts']>0){
			$message .= $result['fb_accounts'].' facebook accounts was added<br>';
		}
		
		if($result['tw_accounts']>0){
			$message .= $result['tw_accounts'].' twitter accounts was added<br>';
		}
		
		if($result['tm_accounts']>0){
			$message .= $result['tm_accounts'].' tumblr accounts was added<br>';
		}
		
		if($result['fb_packeges']>0){
			$message .= $result['fb_packeges'].' facebook packeges was added<br>';
		}		
		
		$this->show($message);
	}
	
	public function delete_bitly(){
		delete_option('cp_bit_ly');	
		$this->show();
	}
	
	public function add_bitly(){
		add_option('cp_bit_ly', 
			serialize(array(
					'bitlyKey' => strip_tags($_POST['bit_key']),
					'bitlyLogin' => strip_tags($_POST['bit_login']),
				))
			);

		$this->show();
	}
}
