<?php


class cp_Spinrewriter{
	public $key = '';
	public $login = '';
	public $service = '';

	function __construct() {
		require_once(__DIR__."/../apis/SpinRewriterAPI.php");

		$options = $this->getOptions();
		
		if(isset($options['mail'])){
			$this->service = new SpinRewriterAPI($options['mail'], $options['key']);
			$this->service->setAutoProtectedTerms(TRUE);
			$this->service->setConfidenceLevel("medium");
			$this->service->setNestedSpintax(FALSE); //!!!
			$this->service->setAutoSentences(true);
			$this->service->setAutoParagraphs(false);
			$this->service->setAutoNewParagraphs(false);
			$this->service->setAutoSentenceTrees(false);
			$this->service->setSpintaxFormat("{|}");
		}else{
			$this->service = NULL;
		}
	}
	
	public function getOptions(){
		$options = get_option('cp_spin_app_settings');
		if(is_string($option)) $option = unserialize($option);
		return $options;
	}

	public function check($mail, $key){
			$service = new SpinRewriterAPI($mail, $key);
			$service->setAutoProtectedTerms(TRUE);
			$service->setConfidenceLevel("medium");
			$service->setNestedSpintax(FALSE); //!!!
			$service->setAutoSentences(true);
			$service->setAutoParagraphs(false);
			$service->setAutoNewParagraphs(false);
			$service->setAutoSentenceTrees(false);
			$service->setSpintaxFormat("{|}");
			$api_response = $service->getTextWithSpintax("Test text here");
			
			if($api_response['status'] == 'ERROR'){
				return false;
			}else{
				return true;
			}
	}

	public function getVariantsFromText($text){
		if(is_null($this->service)){
			return array('status'=> 'ERROR', 'response' => "Not registered service.");
		};

		if(isset($text) && '' != $text){
			$api_response = $this->service->getTextWithSpintax($text);
			if($api_response['status'] == "OK"){
				$api_response['data'] = $this->getVariantsFromPentax($api_response['response']);
				if(0 == count($api_response['data'])){
					$api_response['data'] = array($text);
				};
				$api_response['media_url'] = $media_url;
			};
		}else{
			$api_response = array();			
		};
		
		return $api_response;
	}

	public function getVariantsFromPentax($pentax){
		$data_res = array();

		preg_match_all("!{(.*?)}!si", $pentax, $out, PREG_PATTERN_ORDER);
		$multyplikator = 4; // Чем меньше параметр, тем меньше жрет памяти и меньше вариантов 
		$count_sections = ceil(count($out[0])/$multyplikator);
		$max_variations_count = 0;
		$start_char = 0;

		for ($index = 0; $index < $count_sections; $index++) {
			if(isset($out[0][($index+1)*$multyplikator])){
				$end_char = strpos($pentax, $out[0][($index+1)*$multyplikator]);
			}else{
				$end_char = strlen($pentax);
			};	

			$text_blok = substr($pentax, $start_char, $end_char - $start_char);
			$data_res[$index] = array();
			$this->getText($text_blok, $data_res[$index]);
			if(count($data_res[$index])>$max_variations_count) $max_variations_count = count($data_res[$index]);

			$start_char = $end_char;
		};

		$random_res = array();
		for ($index1 = 0; $index1 < $max_variations_count; $index1++) {
			foreach ($data_res as $data_block){
				if(count($data_block) > $index1){
					$coor_index = $index1;
				}else{
					$coor_index = $index1 % count($data_block);
				};

				if(!isset($random_res[$index1])) $random_res[$index1] = '';
				$random_res[$index1] .= $data_block[$coor_index];
			}
		};

		return $random_res;
	}
	
	public function getText($text, &$data){
			$has_patern = preg_match("!{(.*?)}!si", $text, $variations);
			if($has_patern){
				$variations_arr = explode('|', $variations[1]);
				foreach($variations_arr as $var_elem){
					if($var_elem){
						$new_text = preg_replace("!{(.*?)}!si", $var_elem, $text, 1);
						$this->getText($new_text,$data);
					}
				};						
			}else{
				$data[] = $text;
			}
		}

	public function	show(){
		$login_error = false;
		
		if(isset($_POST['mail']) && isset($_POST['key'])){
			if($this->check($_POST['mail'], $_POST['key'])){
				update_option('cp_spin_app_settings', array('mail'=> $_POST['mail'], 'key' => $_POST['key']));
			}else{
				$login_error = true;
			}
		}

		$options = $this->getOptions();
		
		$active_state = 'sp';	
		include_once(__DIR__.'/../forms/manage/spinrewriter/show.php');	
	}
	
	public function delete(){
		delete_option('cp_spin_app_settings');
		$this->show();
	}
	
	public function isConnected(){
		if(is_null($this->service)){
			return false;
		}else{
			return true;
		}
	}
}