<?php

class cp_Tumblr{
	public $tumbler_connection;
	
	function __construct($settings) {
		global $wpdb;
		$this->connection_settings = $settings;
		
		$this->tumbler_connection = new TumblrOAuth($settings['consumer_key'], $settings['consumer_secret']);
		
		$this->tbl_account_tumblr   = $wpdb->prefix . 'sp_account_tm';
   }	
   
    public function show(){
		global $wpdb;
		$message = '';
		$url = '';
	
		$app_settings = get_option('cp_tumblr_app_settings');
		if (empty($app_settings['consumer_key']) or empty($app_settings['consumer_secret']))
		{
			js_redirect('admin.php?page=manage_accounts&action=app_settings&type=tumblr');
		}
		
		if(!empty($_GET['oauth_verifier']) &&
			!empty($_SESSION['tumbler_token']['oauth_token']) && 
			!empty($_GET['oauth_token']) &&
			$_SESSION['tumbler_token']['oauth_token'] == $_GET['oauth_token']){// ЕСЛИ ПОЛЬЗОВАТЕЛЬ АВТОРИЗОВАЛСЯ ЧЕРЕЗ ССЫЛКУ

			$new_connection = new TumblrOAuth(
									$this->connection_settings['consumer_key'],
									$this->connection_settings['consumer_secret'],
									$_SESSION['tumbler_token']['oauth_token'],
									$_SESSION['tumbler_token']['oauth_token_secret']
								);

			try {
				$access_token = $new_connection->getAccessToken($_GET['oauth_verifier']);
			} catch (Exception $exc) {
				$access_token = null;
			};

			if(isset($access_token['oauth_token'])){
				$authorized_connection = new TumblrOAuth(
									$this->connection_settings['consumer_key'],
									$this->connection_settings['consumer_secret'],
									$access_token['oauth_token'],
									$access_token['oauth_token_secret']
								);
				$user_info = $authorized_connection->getUserInfo();

				$tw_user_info = $wpdb->get_row("SELECT * FROM `" . $this->tbl_account_tumblr . "` WHERE `tm_id`= '".$user_info->name."'", ARRAY_A);

				if(is_null($tw_user_info)){
						$wpdb->insert( $this->tbl_account_tumblr, array( 
																'tm_id' => $user_info->name,
																'name' => $user_info->name, 
																'oauth_token' => $access_token['oauth_token'], 
																'oauth_secret' => $access_token['oauth_token_secret']
															));
						$message =  'Пользователь добавлен';
				} else {
					$wpdb->update( 
								$this->tbl_account_tumblr, 
								array( 
									'name' => $user_info->name, 
									'oauth_token' => $access_token['oauth_token'], 
									'oauth_secret' => $access_token['oauth_token_secret']
								), 
								array( 'id' => $tw_user_info['id'] )
							);
					$message = 'Данные пользователя обновлены';
				}
			}
		}else{ //ЕСЛИ ПОЛЬЗОВАТЕЛЬ ЕЩЁ НЕ АВТОРИЗОВАН
			unset($_SESSION['tumbler_token']);
			
			try {
				$_SESSION['tumbler_token'] = $token = $this->tumbler_connection->getRequestToken();
				$url = $this->tumbler_connection->getAuthorizeURL($token);
			} catch (Exception $exc) {
				unset($_SESSION['tumbler_token']);
				$url = '';
			};
		};	
	
		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->tbl_account_tumblr . "`", ARRAY_A);

		$active_state = 'tm';	
		include_once(__DIR__.'/../forms/manage/tumblr/show_tm.php');			
	}
	
	public function delete(){
		global $wpdb;
		$wpdb->delete( $this->tbl_account_tumblr, array( 'id' => $_GET['id'] ), array( '%d' ) );

		$this->show();		
	}
	
	public function prepare_post($tm_post, $descript_params){
		//see params http://www.tumblr.com/docs/en/api/v2#posts
		
		$url = get_permalink($tm_post->ID);
		if(isset($descript_params['url']) && strlen($descript_params['url'])>3){
			$url = $descript_params['url'];
		};

		$res_post = array(); 
		$res_post['type'] = 'text'; //The type of post to create. Specify one of the following:  text, photo, quote, link, chat, audio, video
		$res_post['state'] = 'published'; //The state of the post. Specify one of the following:  published, draft, queue, private 
		$res_post['tags'] = isset($descript_params['tags'])?$descript_params['tags']:implode(',',wp_get_post_tags($tm_post->ID, array('fields'=>'names'))); //Comma-separated tags for this post
//		$res_post['tweet'] = '';
//		$res_post['date '] = ''; //The GMT date and time of the post, as a string
//		$res_post['format'] = ''; // Supported formats are: html & markdown
		$res_post['slug'] = 'Add a short text summary to the end of the post URL'; //Add a short text summary to the end of the post URL
		
		// Text Posts
		$res_post['title'] = $tm_post->post_title;
		$res_post['body'] = isset($descript_params['message'])?$descript_params['message']:$tm_post->post_content; 
		$res_post['body'] .= '<br><a href="'.$url.'">'.$url.'</a>';
		
		// Photo Posts
		if(!is_null($descript_params['media']) && '' != $descript_params['media']){
			if(in_array(strtoupper(substr($descript_params['media'], -3)), array('PNG', 'JPG', 'GIF'))){
				$img = wp_remote_get($descript_params['media']);
				
				$res_post['caption'] = isset($descript_params['title'])?$descript_params['title']:$tm_post->post_title; 
				$res_post['link'] = $url; 
				$res_post['source'] = $descript_params['media']; 
				$res_post['data'] = $img['body'];
				$res_post['type'] = 'photo';
			}
		};
		
		if(!is_null($descript_params['media']) && strpos($descript_params['media'], 'youtube.com')){
				$caption = isset($descript_params['title'])?$descript_params['title']:$tm_post->post_title;
				$res_post['caption'] = '<a href="'.$url.'">'.$caption.'</a>'; 
				$res_post['embed'] = $descript_params['media'];
				$res_post['type'] = 'video';
		};		
		
		// Link Posts
//		$res_post['title'] = ''; 
//		$res_post['url'] = $url; 
//		$res_post['description'] = ''; 
		
		//Quote Posts
//		$res_post['quote'] = ''; 
//		$res_post['source'] = ''; 
		
		return $res_post;
	}	
	
	public function post_from_user($user,  WP_Post $wp_post, $descript_params = array()){
		$tumblr = new TumblrOAuth(
								$this->connection_settings['consumer_key'],
								$this->connection_settings['consumer_secret'],
								$user['oauth_token'],
								$user['oauth_secret']
							);
		
		$t_post = $this->prepare_post($wp_post, $descript_params);
		$res = $tumblr->post('blog/'.$user['tm_id'].'.tumblr.com/post', $t_post);
		
		return $res;
	}

	public function app_settings(){
		if(isset($_POST['consumer_key']) && isset($_POST['consumer_secret'])){
			$settings = array(
					'consumer_key'=>trim($_POST['consumer_key']),
					'consumer_secret'=>trim($_POST['consumer_secret'])
				);
			
			update_option('cp_tumblr_app_settings', $settings);
			
			js_redirect('admin.php?page=manage_accounts&action=show&type=tumblr');
		}
		
		$app_settings = get_option('cp_tumblr_app_settings');
		
		$active_state = 'tm';
		include_once(__DIR__.'/../forms/manage/tumblr/app_settings.php');	
	}		
	
 }
?>
