<?php
class cp_Twitter{
	public $twitter_connection;
	
	function __construct($settings) {
		global $wpdb;
		$this->connection_settings = $settings;
		
		$this->tbl_account_tw   = $wpdb->prefix . 'sp_account_tw';
   }	
   
    public function show(){
		global $wpdb;
		$error_message = '';
		
		try {
			$twitteroauth = new TwitterOAuth($this->connection_settings['consumer_key'], $this->connection_settings['consumer_secret']);
			$request_token = $twitteroauth->getRequestToken(get_site_url().'/wp-admin/admin.php?page=manage_accounts&action=add&type=twitter');
			$_SESSION['oauth_token'] = $request_token['oauth_token'];
			$_SESSION['oauth_token_secret'] = $request_token['oauth_token_secret'];			
		} catch (Exception $exc) {
			$twitteroauth = null;
		}

		if(!is_null($twitteroauth) && $twitteroauth->http_code==200){
			$url = $twitteroauth->getAuthorizeURL($request_token['oauth_token']);
		} else {
			$url = '';
			$error_message = 'Can not connect to Twitter';
		}			
					
		$accounts = $wpdb->get_results("SELECT * FROM `" . $this->tbl_account_tw . "`", ARRAY_A);
		$active_state = 'tw';	
		include_once(__DIR__.'/../forms/manage/twitter/show_tw.php');			
	}
	
    public function add(){
		global $wpdb;

		if(!empty($_GET['oauth_verifier']) && !empty($_SESSION['oauth_token']) && !empty($_SESSION['oauth_token_secret'])){// ЕСЛИ ПОЛЬЗОВАТЕЛЬ АВТОРИЗОВАЛСЯ ЧЕРЕЗ ССЫЛКУ
			$twitteroauth = new TwitterOAuth(
											$this->connection_settings['consumer_key'],
											$this->connection_settings['consumer_secret'],
											$_SESSION['oauth_token'],
											$_SESSION['oauth_token_secret']
										);
			
			$access_token = $twitteroauth->getAccessToken($_GET['oauth_verifier']);

			if(isset($access_token['oauth_token_secret'])){
				$_SESSION['access_token'] = $access_token;
				$user_info = $twitteroauth->get('account/verify_credentials');
				$tw_user_info = $wpdb->get_row("SELECT * FROM `" . $this->tbl_account_tw . "` WHERE `tw_id`= '".$user_info->id."'", ARRAY_A);

				if(is_null($tw_user_info)){
					$wpdb->insert( $this->tbl_account_tw, array( 
															'tw_id' => $user_info->id,
															'name' => $user_info->screen_name,
															'image' => $user_info->profile_image_url,
															'oauth_token' => $access_token['oauth_token'], 
															'oauth_secret' => $access_token['oauth_token_secret']
														));
						//echo 'Пользователь добавлен';
				} else {
					$wpdb->update( 
								$this->tbl_account_tw, 
								array( 
									'name' => $user_info->screen_name, 
									'oauth_token' => $access_token['oauth_token'], 
									'oauth_secret' => $access_token['oauth_token_secret']
								), 
								array( 'id' => $tw_user_info['id'] )
							);
					//echo 'Данные пользователя обновлены';
				}			
			};
		}else{ //ЕСЛИ ПОЛЬЗОВАТЕЛЬ ЕЩЁ НЕ АВТОРИЗОВАН
			//echo 'Что то не так';
		};
		
		$this->show();
	}
	
	public function delete(){
		global $wpdb;
		$wpdb->delete( $this->tbl_account_tw, array( 'id' => $_GET['id'] ), array( '%d' ) );

		$this->show();		
	}
	
	public function prepare_post($wp_post, $descript_params){
		$avalible_length = 140;
		
		$str = get_permalink($wp_post->ID);
		if(isset($descript_params['url']) && strlen($descript_params['url'])>3){
			$str = $descript_params['url'];
		};
		
		$avalible_length = 140 - strlen($str);

		if(isset($descript_params['message']) && strlen($descript_params['message']) > 1){
			if(strlen($descript_params['message']) > $avalible_length){
				$str = substr($descript_params['message'], 0, $avalible_length-1).' '.$str;
			}else{
				$str = $descript_params['message'].' '.$str;
			}
		}else{
			if(strlen($wp_post->post_title) >= $avalible_length){
				$str = substr($wp_post->post_title, 0, $avalible_length).$str;
			}elseif($avalible_length < 20){
				$str = $wp_post->post_title.' '.$str;
			}else{
				$avalible_length -= strlen($wp_post->post_title)+5;
				$str = $wp_post->post_title.' '.substr($wp_post->post_title, 0, $avalible_length).'... '.$str;
			};		
		}
		


		$res_post = array(); 
		$res_post['status'] = $str;
		$res_post['media[]'] = null;
		
//		$res_post['in_reply_to_status_id'] = '';
//		$res_post['lat '] = '';
//		$res_post['long'] = '';
//		$res_post['place_id '] = '';
//		$res_post['display_coordinates'] = '';
//		$res_post['trim_user  '] = '';
		
		if(!is_null($descript_params['media']) && '' != $descript_params['media']){
			if(in_array(strtoupper(substr($descript_params['media'], -3)), array('PNG', 'JPG', 'GIF'))){
				$img = wp_remote_get($descript_params['media']);
				$res_post['media[]'] = $img['body'];
			}
		};
		
		return $res_post;
	}	
	
	public function post_from_user($user,  WP_Post $wp_post, $descript_params = array()){
		require_once(__DIR__.'/../apis/tmhOAuth.php');
		$tmhOAuth = new NXS_tmhOAuth(array( 
										'consumer_key' => $this->connection_settings['consumer_key'],
										'consumer_secret' => $this->connection_settings['consumer_secret'], 
										'user_token' => $user['oauth_token'],
										'user_secret' => $user['oauth_secret']
									));  
		
		$tw_post = $this->prepare_post($wp_post, $descript_params);
		
		if(is_null($tw_post['media[]'])){
			$res = $tmhOAuth->request('POST', 'https://api.twitter.com/1.1/statuses/update.json', $tw_post, true);
		}else{
			$res = $tmhOAuth -> request('POST', 'https://api.twitter.com/1.1/statuses/update_with_media.json', $tw_post, true, true);
		};

		return 200 == $res;
	}
	
	public function app_settings(){
		if(isset($_POST['consumer_key']) && isset($_POST['consumer_secret'])){
			$settings = array(
					'consumer_key'=>trim($_POST['consumer_key']),
					'consumer_secret'=>trim($_POST['consumer_secret'])
				);
			
			update_option('cp_twitter_app_settings', $settings);
		}
		
		$app_settings = get_option('cp_twitter_app_settings');
		
		$active_state = 'tw';
		include_once('/../forms/manage/twitter/app_settings.php');	
	}	
 }
?>
